<?php
  /**************************************************************************\
  * phpGroupWare                                                             *
  * http://www.phpgroupware.org                                              *
  * --------------------------------------------                             *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/

  /* $Id: header.inc.php,v 1.18.2.1 2002/04/05 13:55:50 skeeter Exp $ */

	function add_col(&$tpl,$str)
	{
		$tpl->set_var('str',$str);
		$tpl->parse('header_column','head_col',True);
	}

	function add_image_ahref($link,$image,$alt)
	{
		return '<a href="'.$link.'"><img src="'.$GLOBALS['phpgw']->common->image('calendar',$image).'" alt="'.$alt.'" border="0"></a>';
	}

	$refer = explode('.',$GLOBALS['HTTP_GET_VARS']['menuaction']);
	$referrer = $refer[2];

	$templates = Array(
		'head_tpl'	=> 'head.tpl',
		'form_button_dropdown'	=> 'form_button_dropdown.tpl',
		'form_button_script'	=> 'form_button_script.tpl'
	);
	$tpl->set_file($templates);
	$tpl->set_block('head_tpl','head','head');
	$tpl->set_block('head_tpl','head_table','head_table');
	$tpl->set_block('head_tpl','head_col','head_col');
	$tpl->set_block('form_button_script','form_button');

	$today = date('Ymd',time());
	$image_dir = PHPGW_IMAGES;
	$day_url = $this->page('day','&date='.$today);
	$day_tab = lang('daily');
	$week_url = $this->page('week','&date='.$today);
	$week_tab = lang('weekly');
	$month_url = $this->page('month','&date='.$today);
	$month_tab = lang('monthly');
	$year_url = $this->page('year','&date='.$today);
	$year_tab = lang('yearly');
	$matrix_url = $this->page('matrixselect','&date='.$today);
	$matrixview_tab = lang('daily matrix view');
	$lang_today_schedule = lang('schedule of today');
	$lang_go = lang('Go!');
	$lang_user_setting = lang('user setting');
	$addressbook_pref_url = $GLOBALS['phpgw']->link('/index.php','menuaction=preferences.uiaclprefs.index&acl_app=calendar');
	switch ($referrer)
	{
	case 'day':
		add_col($tpl,"<td width='10' height='27' align='right' valign='bottom'><img SRC='$image_dir/tag_l.gif' WIDTH='10' HEIGHT='27'></td>");
		add_col($tpl,"<td background='$image_dir/tag_bg_01.gif' nowrap class='tagB'>$day_tab</td>");
		add_col($tpl,"<td width='23' align='right' valign='bottom'><img SRC='$image_dir/tag_btw01.gif' WIDTH='23' HEIGHT='27'></td>");
		add_col($tpl,"<td background='$image_dir/tag_bg_02.gif' nowrap><a HREF='$week_url'><span class='tag' id='tFFFFFF'>$week_tab</span></a></td>");
		add_col($tpl,"<td width='23' align='right' valign='bottom'><img SRC='$image_dir/tag_btw02.gif' WIDTH='23' HEIGHT='27'></td>");
		add_col($tpl,"<td background='$image_dir/tag_bg_02.gif' nowrap><a HREF='$month_url'><span class='tag' id='tFFFFFF'>$month_tab</span></a></td>");
		add_col($tpl,"<td width='23' align='right' valign='bottom'><img SRC='$image_dir/tag_btw02.gif' WIDTH='23' HEIGHT='27'></td>");
		add_col($tpl,"<td background='$image_dir/tag_bg_02.gif' nowrap><a HREF='$year_url'><span class='tag' id='tFFFFFF'>$year_tab</span></a></td>");
		add_col($tpl,"<td width='23' align='right' valign='bottom'><img SRC='$image_dir/tag_btw02.gif' WIDTH='23' HEIGHT='27'></td>");
		// Removed By Kazuya Nouchi POPCOM INC 2002/12/11
//		add_col($tpl,"<td background='$image_dir/tag_bg_02.gif' nowrap><a HREF='$matrix_url'><span class='tag' id='tFFFFFF'>$matrixview_tab</span></a></td>");
//		add_col($tpl,"<td width='23' align='right' valign='bottom'><img SRC='$image_dir/tag_btw02.gif' WIDTH='23' HEIGHT='27'></td>");
		//--------------------------------------------------
		add_col($tpl,"<td background='$image_dir/tag_bg_02.gif' nowrap><a HREF='$addressbook_pref_url'><span class='tag' id='tFFFFFF'>$lang_user_setting</span></a></td>");
		add_col($tpl,"<td width='21' align='right' valign='bottom'><img SRC='$image_dir/tag_r.gif' WIDTH='21' HEIGHT='27'></td>");
		$tpl->set_var('lang_display_span',lang('dayly display span'));
		break;
	case 'week':
		add_col($tpl,"<td width='10' height='27' align='right' valign='bottom'><img SRC='$image_dir/tag_l02.gif' WIDTH='10' HEIGHT='27'></td>");
		add_col($tpl,"<td background='$image_dir/tag_bg_02.gif' nowrap><a HREF='$day_url'><span class='tag' id='tFFFFFF'>$day_tab</span></a></td>");
		add_col($tpl,"<td width='23' align='right' valign='bottom'><img SRC='$image_dir/tag_btw03.gif' WIDTH='23' HEIGHT='27'></td>");
		add_col($tpl,"<td background='$image_dir/tag_bg_01.gif' nowrap class='tagB'>$week_tab</td>");
		add_col($tpl,"<td width='23' align='right' valign='bottom'><img SRC='$image_dir/tag_btw01.gif' WIDTH='23' HEIGHT='27'></td>");
		add_col($tpl,"<td background='$image_dir/tag_bg_02.gif' nowrap><a HREF='$month_url'><span class='tag' id='tFFFFFF'>$month_tab</span></a></td>");
		add_col($tpl,"<td width='23' align='right' valign='bottom'><img SRC='$image_dir/tag_btw02.gif' WIDTH='23' HEIGHT='27'></td>");
		add_col($tpl,"<td background='$image_dir/tag_bg_02.gif' nowrap><a HREF='$year_url'><span class='tag' id='tFFFFFF'>$year_tab</span></a></td>");
		add_col($tpl,"<td width='23' align='right' valign='bottom'><img SRC='$image_dir/tag_btw02.gif' WIDTH='23' HEIGHT='27'></td>");
		// Removed By Kazuya Nouchi POPCOM INC 2002/12/11
//		add_col($tpl,"<td background='$image_dir/tag_bg_02.gif' nowrap><a HREF='$matrix_url'><span class='tag' id='tFFFFFF'>$matrixview_tab</span></a></td>");
//		add_col($tpl,"<td width='23' align='right' valign='bottom'><img SRC='$image_dir/tag_btw02.gif' WIDTH='23' HEIGHT='27'></td>");
		//-----------------------------------------------------
		add_col($tpl,"<td background='$image_dir/tag_bg_02.gif' nowrap><a HREF='$addressbook_pref_url'><span class='tag' id='tFFFFFF'>$lang_user_setting</span></a></td>");
		add_col($tpl,"<td width='21' align='right' valign='bottom'><img SRC='$image_dir/tag_r.gif' WIDTH='21' HEIGHT='27'></td>");	
		add_col($tpl, "<td width='25' align='right' nowrap><a HREF='$day_url'><img SRC='$image_dir/clnd_icn_s.gif' WIDTH='12' HEIGHT='16' border='0' alt='' title='$lang_today_schedule'></a><img SRC='$image_dir/spacer10.gif' WIDTH='3' HEIGHT='1'></td>");
		add_col($tpl, "<td nowrap><a HREF='$day_url'><span class='nomal10' id='t000000''>$lang_today_schedule</span></a></td>");
		$tpl->set_var('lang_display_span',lang('weekly display span'));
		$week_url = $this->page('week','');
		$thisdate = mktime(0,0,0,$this->bo->month,$this->bo->day,$this->bo->year) - $this->tz_offset;
		$sun = $this->bo->datetime->get_weekday_start($this->bo->year,$this->bo->month,$this->bo->day) - $this->tz_offset;
		$option = '';
		for ($i = -7; $i <= 7; $i++)
		{
			$begin = $sun + (604800 * $i);
			$end = $begin + 604799;
			$option .= '<option value="' . $GLOBALS['phpgw']->common->show_date($begin,'Ymd') . '"'.($begin <= $thisdate && $end >= $thisdate?' selected':'').'>'
				   . $GLOBALS['phpgw']->common->show_date($begin,$GLOBALS['phpgw_info']['user']['preferences']['common']['dateformat']) . ' - '
				   . $GLOBALS['phpgw']->common->show_date($end,$GLOBALS['phpgw_info']['user']['preferences']['common']['dateformat'])."</option>\n";
		}
		$disp_span = "<td><form action='$week_url' method='post' name='SelectWeek'>\n";
		$disp_span .= "<select name='date' onchange='document.SelectWeek.submit()'>\n";
		$disp_span .= $option;
		$disp_span .= "</select>\n<noscript><input type='submit' value='$lang_go'></noscript>\n</td></form>\n";
		$tpl->set_var('calendar_span',$disp_span);
		break;
	case 'month':
		add_col($tpl, "<td width='10' height='27' align='right' valign='bottom'><img SRC='$image_dir/tag_l02.gif' WIDTH='10' HEIGHT='27'></td>");
		add_col($tpl, "<td background='$image_dir/tag_bg_02.gif' nowrap><a HREF='$day_url'><span class='tag' id='tFFFFFF'>$day_tab</span></a></td>");
		add_col($tpl, "<td width='23' align='right' valign='bottom'><img SRC='$image_dir/tag_btw02.gif' WIDTH='23' HEIGHT='27'></td>");
		add_col($tpl, "<td background='$image_dir/tag_bg_02.gif' nowrap><a HREF='$week_url'><span class='tag' id='tFFFFFF'>$week_tab</span></a></td>");
		add_col($tpl, "<td width='23' align='right' valign='bottom'><img SRC='$image_dir/tag_btw03.gif' WIDTH='23' HEIGHT='27'></td>");
		add_col($tpl, "<td background='$image_dir/tag_bg_01.gif' nowrap class='tagB'>$month_tab</td>");
		add_col($tpl, "<td width='23' align='right' valign='bottom'><img SRC='$image_dir/tag_btw01.gif' WIDTH='23' HEIGHT='27'></td>");
		add_col($tpl, "<td background='$image_dir/tag_bg_02.gif' nowrap><a HREF='$year_url'><span class='tag' id='tFFFFFF'>$year_tab</span></a></td>");
		add_col($tpl, "<td width='23' align='right' valign='bottom'><img SRC='$image_dir/tag_btw02.gif' WIDTH='23' HEIGHT='27'></td>");
		// Removed By Kazuya Nouchi POPCOM INC 2002/12/11
//		add_col($tpl, "<td background='$image_dir/tag_bg_02.gif' nowrap><a HREF='$matrix_url'><span class='tag' id='tFFFFFF'>$matrixview_tab</span></a></td>");
//		add_col($tpl, "<td width='23' align='right' valign='bottom'><img SRC='$image_dir/tag_btw02.gif' WIDTH='23' HEIGHT='27'></td>");
		//-----------------------------------------------------
		add_col($tpl, "<td background='$image_dir/tag_bg_02.gif' nowrap><a HREF='$addressbook_pref_url'><span class='tag' id='tFFFFFF'>$lang_user_setting</span></a></td>");
		add_col($tpl, "<td width='21' align='right' valign='bottom'><img SRC='$image_dir/tag_r.gif' WIDTH='21' HEIGHT='27'></td>");
		add_col($tpl, "<td width='25' align='right' nowrap><a HREF='$day_url'><img SRC='$image_dir/clnd_icn_s.gif' WIDTH='12' HEIGHT='16' border='0' alt='' title='$lang_today_schedule'></a><img SRC='$image_dir/spacer10.gif' WIDTH='3' HEIGHT='1'></td>");
		add_col($tpl, "<td nowrap><a HREF='$day_url'><span class='nomal10' id='t000000''>$lang_today_schedule</span></a></td>");
		$tpl->set_var('lang_display_span',lang('monthly display span'));
		$month_url = $this->page('month','');
		$m = $this->bo->month;
		$y = $this->bo->year;
		$thisdate = date('Ymd',mktime(0,0,0,$m,1,$y));
		$y--;
		$option = '';
		for ($i = 0; $i < 25; $i++)
		{
			$m++;
			if ($m > 12)
			{
				$m = 1;
				$y++;
			}
			$d = mktime(0,0,0,$m,1,$y);
			$d_ymd = date('Ymd',$d);
			$option .= '<option value="'.$d_ymd.'"'.($d_ymd == $thisdate?' selected':'').'>'.strftime(' %Y', $d).lang('year').lang(date('F', $d)).'</option>'."\n";
		}
		$disp_span = "<td><form action='$month_url' method='post' name='SelectMonth'>\n";
		$disp_span .= "<select name='date' onchange='document.SelectMonth.submit()'>\n";
		$disp_span .= $option;
		$disp_span .= "</select>\n<noscript><input type='submit' value='$lang_go'></noscript>\n</td></form>\n";
		$tpl->set_var('calendar_span',$disp_span);
		break;
	case 'year':
		add_col($tpl, "<td width='10' height='27' align='right' valign='bottom'><img SRC='$image_dir/tag_l02.gif' WIDTH='10' HEIGHT='27'></td>");
		add_col($tpl, "<td background='$image_dir/tag_bg_02.gif' nowrap><a HREF='$day_url'><span class='tag' id='tFFFFFF'>$day_tab</span></a></td>");
		add_col($tpl, "<td width='23' align='right' valign='bottom'><img SRC='$image_dir/tag_btw02.gif' WIDTH='23' HEIGHT='27'></td>");
		add_col($tpl, "<td background='$image_dir/tag_bg_02.gif' nowrap><a HREF='$week_url'><span class='tag' id='tFFFFFF'>$week_tab</span></a></td>");
		add_col($tpl, "<td width='23' align='right' valign='bottom'><img SRC='$image_dir/tag_btw02.gif' WIDTH='23' HEIGHT='27'></td>");
		add_col($tpl,"<td background='$image_dir/tag_bg_02.gif' nowrap><a HREF='$month_url'><span class='tag' id='tFFFFFF'>$month_tab</span></a></td>");
		add_col($tpl,"<td width='23' align='right' valign='bottom'><img SRC='$image_dir/tag_btw03.gif' WIDTH='23' HEIGHT='27'></td>");
		add_col($tpl,"<td background='$image_dir/tag_bg_01.gif' nowrap class='tagB'>$year_tab</td>");
		add_col($tpl,"<td width='23' align='right' valign='bottom'><img SRC='$image_dir/tag_btw01.gif' WIDTH='23' HEIGHT='27'></td>");
		// Removed By Kazuya Nouchi POPCOM INC 2002/12/11
//		add_col($tpl, "<td background='$image_dir/tag_bg_02.gif' nowrap><a HREF='$matrix_url'><span class='tag' id='tFFFFFF'>$matrixview_tab</span></a></td>");
//		add_col($tpl, "<td width='23' align='right' valign='bottom'><img SRC='$image_dir/tag_btw02.gif' WIDTH='23' HEIGHT='27'></td>");
		//-------------------------------------------------------
		add_col($tpl, "<td background='$image_dir/tag_bg_02.gif' nowrap><a HREF='$addressbook_pref_url'><span class='tag' id='tFFFFFF'>$lang_user_setting</span></a></td>");
		add_col($tpl, "<td width='21' align='right' valign='bottom'><img SRC='$image_dir/tag_r.gif' WIDTH='21' HEIGHT='27'></td>");
		add_col($tpl, "<td width='25' align='right' nowrap><a HREF='$day_url'><img SRC='$image_dir/clnd_icn_s.gif' WIDTH='12' HEIGHT='16' border='0' alt='' title='$lang_today_schedule'></a><img SRC='$image_dir/spacer10.gif' WIDTH='3' HEIGHT='1'></td>");
		add_col($tpl, "<td nowrap><a HREF='$day_url'><span class='nomal10' id='t000000''>$lang_today_schedule</span></a></td>");
		$tpl->set_var('lang_display_span',lang('yearly display span'));
		$year_url = $this->page('year','');
		$option = '';
		for ($i = ($this->bo->year - 3); $i < ($this->bo->year + 3); $i++)
		{
			$option .= '<option value="'.$i.'"'.($i == $this->bo->year?' selected':'').'>'.$i.lang('year').'</option>'."\n";
		}
		$disp_span = "<td><form action='$year_url' method='post' name='SelectYear'>\n";
		$disp_span .= "<select name='year' onchange='document.SelectYear.submit()'>\n";
		$disp_span .= $option;
		$disp_span .= "</select>\n<noscript><input type='submit' value='$lang_go'></noscript>\n</td></form>\n";
		$tpl->set_var('calendar_span',$disp_span);		
		break;
	case 'planner':
		break;
	case 'matrixselect':
		add_col($tpl, "<td width='10' height='27' align='right' valign='bottom'><img SRC='$image_dir/tag_l02.gif' WIDTH='10' HEIGHT='27'></td>");
		add_col($tpl, "<td background='$image_dir/tag_bg_02.gif' nowrap><a HREF='$day_url'><span class='tag' id='tFFFFFF'>$day_tab</span></a></td>");
		add_col($tpl, "<td width='23' align='right' valign='bottom'><img SRC='$image_dir/tag_btw02.gif' WIDTH='23' HEIGHT='27'></td>");
		add_col($tpl, "<td background='$image_dir/tag_bg_02.gif' nowrap><a HREF='$week_url'><span class='tag' id='tFFFFFF'>$week_tab</span></a></td>");
		add_col($tpl, "<td width='23' align='right' valign='bottom'><img SRC='$image_dir/tag_btw02.gif' WIDTH='23' HEIGHT='27'></td>");
		add_col($tpl,"<td background='$image_dir/tag_bg_02.gif' nowrap><a HREF='$month_url'><span class='tag' id='tFFFFFF'>$month_tab</span></a></td>");
		add_col($tpl,"<td width='23' align='right' valign='bottom'><img SRC='$image_dir/tag_btw02.gif' WIDTH='23' HEIGHT='27'></td>");
		add_col($tpl,"<td background='$image_dir/tag_bg_02.gif' nowrap><a HREF='$year_url'><span class='tag' id='tFFFFFF'>$year_tab</span></a></td>");
		add_col($tpl,"<td width='23' align='right' valign='bottom'><img SRC='$image_dir/tag_btw03.gif' WIDTH='23' HEIGHT='27'></td>");
		add_col($tpl,"<td background='$image_dir/tag_bg_01.gif' nowrap class='tagB'>$matrixview_tab</td>");
		add_col($tpl,"<td width='23' align='right' valign='bottom'><img SRC='$image_dir/tag_btw01.gif' WIDTH='23' HEIGHT='27'></td>");
		add_col($tpl, "<td background='$image_dir/tag_bg_02.gif' nowrap><a HREF='$addressbook_pref_url'><span class='tag' id='tFFFFFF'>$lang_user_setting</span></a></td>");
		add_col($tpl, "<td width='21' align='right' valign='bottom'><img SRC='$image_dir/tag_r.gif' WIDTH='21' HEIGHT='27'></td>");			
		add_col($tpl, "<td width='25' align='right' nowrap><a HREF='$day_url'><img SRC='$image_dir/clnd_icn_s.gif' WIDTH='12' HEIGHT='16' border='0' alt='' title='$lang_today_schedule'></a><img SRC='$image_dir/spacer10.gif' WIDTH='3' HEIGHT='1'></td>");
		add_col($tpl, "<td nowrap><a HREF='$day_url'><span class='nomal10' id='t000000''>$lang_today_schedule</span></a></td>");
		$tpl->set_var('lang_display_span',lang('matrixview display description'));
		break;
	case 'search':
	case 'view':
	case 'reinstate_list':
		add_col($tpl, "<td width='10' height='27' align='right' valign='bottom'><img SRC='$image_dir/tag_l02.gif' WIDTH='10' HEIGHT='27'></td>");
		add_col($tpl, "<td background='$image_dir/tag_bg_02.gif' nowrap><a HREF='$day_url'><span class='tag' id='tFFFFFF'>$day_tab</span></a></td>");
		add_col($tpl, "<td width='23' align='right' valign='bottom'><img SRC='$image_dir/tag_btw02.gif' WIDTH='23' HEIGHT='27'></td>");
		add_col($tpl, "<td background='$image_dir/tag_bg_02.gif' nowrap><a HREF='$week_url'><span class='tag' id='tFFFFFF'>$week_tab</span></a></td>");
		add_col($tpl, "<td width='23' align='right' valign='bottom'><img SRC='$image_dir/tag_btw02.gif' WIDTH='23' HEIGHT='27'></td>");
		add_col($tpl,"<td background='$image_dir/tag_bg_02.gif' nowrap><a HREF='$month_url'><span class='tag' id='tFFFFFF'>$month_tab</span></a></td>");
		add_col($tpl,"<td width='23' align='right' valign='bottom'><img SRC='$image_dir/tag_btw02.gif' WIDTH='23' HEIGHT='27'></td>");
		add_col($tpl,"<td background='$image_dir/tag_bg_02.gif' nowrap><a HREF='$year_url'><span class='tag' id='tFFFFFF'>$year_tab</span></a></td>");
		add_col($tpl,"<td width='23' align='right' valign='bottom'><img SRC='$image_dir/tag_btw02.gif' WIDTH='23' HEIGHT='27'></td>");
		// Removed By Kazuya Nouchi POPCOM INC 2002/12/11
//		add_col($tpl,"<td background='$image_dir/tag_bg_02.gif' nowrap><a HREF='$matrix_url'><span class='tag' id='tFFFFFF'>$matrixview_tab</span></a></td>");
//		add_col($tpl,"<td width='23' align='right' valign='bottom'><img SRC='$image_dir/tag_btw02.gif' WIDTH='23' HEIGHT='27'></td>");
		//-----------------------------------------------------------
		add_col($tpl, "<td background='$image_dir/tag_bg_02.gif' nowrap><a HREF='$addressbook_pref_url'><span class='tag' id='tFFFFFF'>$lang_user_setting</span></a></td>");
		add_col($tpl, "<td width='21' align='right' valign='bottom'><img SRC='$image_dir/tag_r.gif' WIDTH='21' HEIGHT='27'></td>");
		add_col($tpl, "<td width='25' align='right' nowrap><a HREF='$day_url'><img SRC='$image_dir/clnd_icn_s.gif' WIDTH='12' HEIGHT='16' border='0' alt='' title='$lang_today_schedule'></a><img SRC='$image_dir/spacer10.gif' WIDTH='3' HEIGHT='1'></td>");
		add_col($tpl, "<td nowrap><a HREF='$day_url'><span class='nomal10' id='t000000''>$lang_today_schedule</span></a></td>");
		if ($referrer == 'search')
			$tpl->set_var('lang_display_span',lang('serach display description'));
		else
		{
			$tpl->set_var('lang_display_span',lang('view display description'));
		}
	}
	$tpl->set_var('image_dir', $image_dir);
	$tpl->set_var('lang_title',lang('calendar'));	
	$var = Array(
		'action_url_button'	=> $GLOBALS['phpgw']->link('/index.php','menuaction=calendar.uiicalendar.import'),
		'action_text_button'	=> lang('imports')
	);
	$tpl->set_var($var);
/*	
	if(floor(phpversion()) >= 4)
	{
		$tpl->set_var('cols',8);
	}
	else
	{
		$tpl->set_var('cols',7);
	}

	$col_width = 12;
*/
	//add_col($tpl,'  <td width="2%">&nbsp;</td>');

	//add_col($tpl,'  <td width="2%">'.add_image_ahref($this->page('day','&date='.$today),'today.gif',lang('Today')).'</td>');

	//add_col($tpl,'  <td width="2%" align="left">'.add_image_ahref($this->page('week','&date='.$today),'week.gif',lang('This week')).'</td>');

	//add_col($tpl,'  <td width="2%" align="left">'.add_image_ahref($this->page('month','&date='.$today),'month.gif',lang('This month')).'</td>');

	//add_col($tpl,'  <td width="2%" align="left">'.add_image_ahref($this->page('year','&date='.$today),'year.gif',lang('This Year')).'</td>');
/*
	if(floor(phpversion()) >= 4)
	{
		add_col($tpl,'  <td width="2%" align="left">'.add_image_ahref($this->page('planner','&date='.$today),'planner.gif',lang('Planner')).'</td>');
		$col_width += 2;
	}

	add_col($tpl,'  <td width="2%" align="left">'.add_image_ahref($this->page('matrixselect'),'view.gif',lang('Daily Matrix View')).'</td>');

	add_col($tpl,'  <td width="'.(100 - $col_width).'%" align="left"'.(floor(phpversion()) < 4?' colspan="2"':'').'>&nbsp;</td>');
*/
	$tpl->parse('row','head_table',True);

	$tpl->set_var('header_column','');
	$tpl->set_var('cols',$cols);

	// Modified By Kazuya Nouchi POPCOM INC 2002/12/20
	if($referrer!='view' && $referrer!='reinstate_list')
	//if($referrer!='view')
	// -----------------------------------------------
	{
		$remainder = 72;
/*
		$hidden_vars = '<input type="hidden" name="from" value="'.$GLOBALS['HTTP_GET_VARS']['menuaction'].'">'."\n";
		if(isset($GLOBALS['HTTP_GET_VARS']['cal_id']) && $GLOBALS['HTTP_GET_VARS']['cal_id'] != 0)
		{
			$hidden_vars .= '    <input type="hidden" name="cal_id" value="'.$GLOBALS['HTTP_GET_VARS']['cal_id'].'">'."\n";
		}
		if(isset($GLOBALS['HTTP_POST_VARS']['keywords']) && $GLOBALS['HTTP_POST_VARS']['keywords'])
		{
			$hidden_vars .= '    <input type="hidden" name="keywords" value="'.$GLOBALS['HTTP_POST_VARS']['keywords'].'">'."\n";
		}
		if(isset($GLOBALS['HTTP_POST_VARS']['matrixtype']) && $GLOBALS['HTTP_POST_VARS']['matrixtype'])
		{
			$hidden_vars .= '    <input type="hidden" name="matrixtype" value="'.$GLOBALS['HTTP_POST_VARS']['matrixtype'].'">'."\n";
		}
		if(isset($GLOBALS['HTTP_POST_VARS']['participants']) && $GLOBALS['HTTP_POST_VARS']['participants'])
		{
			for ($i=0;$i<count($GLOBALS['HTTP_POST_VARS']['participants']);$i++)
			{
				$hidden_vars .= '    <input type="hidden" name="participants[]" value="'.$GLOBALS['HTTP_POST_VARS']['participants'][$i].'">'."\n";
			}
		}
		if($this->debug) { echo 'Cat ID = ('.$this->bo->cat_id.")<br>\n"; }

		$var = Array(
			'form_width' => '28',
			'form_link'	=> $this->page($referrer),
			'form_name'	=> 'cat_id',
			'title'	=> lang('Category'),
			'hidden_vars'	=> $hidden_vars,
			'form_options'	=> '<option value="0">All</option>'.$this->cat->formated_list('select','all',$this->bo->cat_id,'True'),
			'button_value'	=> lang('Go!')
		);
		$tpl->set_var($var);
		$tpl->set_var('str',$tpl->fp('out','form_button_dropdown'));
		$tpl->parse('header_column','head_col',True);
*/
		if($this->bo->check_perms(PHPGW_ACL_PRIVATE))
		{
			$remainder -= 28;
			$hidden_vars = '<input type="hidden" name="from" value="'.$GLOBALS['HTTP_GET_VARS']['menuaction'].'">'."\n";
			if(isset($GLOBALS['HTTP_GET_VARS']['cal_id']) && $GLOBALS['HTTP_GET_VARS']['cal_id'] != 0)
			{
				$hidden_vars .= '    <input type="hidden" name="cal_id" value="'.$GLOBALS['HTTP_GET_VARS']['cal_id'].'">'."\n";
			}
			if(isset($GLOBALS['HTTP_POST_VARS']['keywords']) && $GLOBALS['HTTP_POST_VARS']['keywords'])
			{
				$hidden_vars .= '    <input type="hidden" name="keywords" value="'.$GLOBALS['HTTP_POST_VARS']['keywords'].'">'."\n";
			}
			if(isset($GLOBALS['HTTP_POST_VARS']['matrixtype']) && $GLOBALS['HTTP_POST_VARS']['matrixtype'])
			{
				$hidden_vars .= '    <input type="hidden" name="matrixtype" value="'.$GLOBALS['HTTP_POST_VARS']['matrixtype'].'">'."\n";
			}
			if(isset($GLOBALS['HTTP_POST_VARS']['participants']) && $GLOBALS['HTTP_POST_VARS']['participants'])
			{
				for ($i=0;$i<count($GLOBALS['HTTP_POST_VARS']['participants']);$i++)
				{
					$hidden_vars .= '    <input type="hidden" name="participants[]" value="'.$GLOBALS['HTTP_POST_VARS']['participants'][$i].'">'."\n";
				}
			}
			if($this->debug) { echo 'Filter = ('.$this->bo->filter.")<br>\n"; }
			$form_options = '<option value=" all "'.($this->bo->filter==' all '?' selected':'').'>'.lang('All').'</option>'."\n";
			$form_options .= '     <option value=" private "'.((!isset($this->bo->filter) || !$this->bo->filter) || $this->bo->filter==' private '?' selected':'').'>'.lang('Private Only').'</option>'."\n";
		
			$var = Array(
//				'form_width' => '28',
				'form_link'	=> $this->page($referrer),
				'form_name'	=> 'filter',
				'title'	=> lang('Filter'),
				'hidden_vars'	=> $hidden_vars,
				'form_options'	=> $form_options,
				'button_value'	=> lang('Go!')
			);
			$tpl->set_var($var);
			$tpl->set_var('str',$tpl->fp('out','form_button_dropdown'));
			$tpl->parse('filter_select','head_col',True);
	//		$tpl->parse('header_column','head_col',True);
		}

		if((!isset($GLOBALS['phpgw_info']['server']['deny_user_grants_access']) || !$GLOBALS['phpgw_info']['server']['deny_user_grants_access']) && count($this->bo->grants) > 0)
		{
			$hidden_vars = '    <input type="hidden" name="from" value="'.$GLOBALS['HTTP_GET_VARS']['menuaction'].'">'."\n";
			if(isset($GLOBALS['HTTP_POST_VARS']['keywords']) && $GLOBALS['HTTP_POST_VARS']['keywords'])
			{
				$hidden_vars .= '    <input type="hidden" name="keywords" value="'.$GLOBALS['HTTP_POST_VARS']['keywords'].'">'."\n";
			}
			if(isset($GLOBALS['HTTP_GET_VARS']['cal_id']) && $GLOBALS['HTTP_GET_VARS']['cal_id'] != 0)
			{
				$hidden_vars .= '    <input type="hidden" name="cal_id" value="'.$GLOBALS['HTTP_GET_VARS']['cal_id'].'">'."\n";
			}
			$hidden_vars .= '    <!-- BO Owner = '.$this->bo->owner.' -->'."\n";
			$form_options = '';
			reset($this->bo->grants);
			while(list($grantor,$temp_rights) = each($this->bo->grants))
			{
				$GLOBALS['phpgw']->accounts->get_account_name($grantor,$lid,$fname,$lname);
				$drop_down[$lname.' '.$fname] = Array(
					'grantor'	=> $grantor,
					'value'		=> ($GLOBALS['phpgw']->accounts->get_type($grantor)=='g'?'g_':'').$grantor,
					'name'		=> $GLOBALS['phpgw']->common->display_fullname($lid,$fname,$lname)
				);
			}
			$memberships = $GLOBALS['phpgw']->accounts->membership($GLOBALS['phpgw_info']['user']['account_id']);
			while($memberships != False && list($key,$group_info) = each($memberships))
			{
				$GLOBALS['phpgw']->accounts->get_account_name($group_info['account_id'],$lid,$fname,$lname);
				$drop_down[$lname.' '.$fname] = Array(
					'grantor'	=> $group_info['account_id'],
					'value'		=> ($GLOBALS['phpgw']->accounts->get_type($group_info['account_id'])=='g'?'g_':'').$group_info['account_id'],
					'name'		=> $GLOBALS['phpgw']->common->display_fullname($lid,$fname,$lname)
				);

				$account_perms = $GLOBALS['phpgw']->acl->get_ids_for_location($group_info['account_id'],PHPGW_ACL_READ,'calendar');
				while($account_perms && list($key,$group_id) = each($account_perms))
				{
					$GLOBALS['phpgw']->accounts->get_account_name($group_id,$lid,$fname,$lname);
					$drop_down[$lname.' '.$fname] = Array(
						'grantor'	=> $group_id,
						'value'		=> ($GLOBALS['phpgw']->accounts->get_type($group_id)=='g'?'g_':'').$group_id,
						'name'		=> $GLOBALS['phpgw']->common->display_fullname($lid,$fname,$lname)
					);
				}
			}
		
			@reset($drop_down);
			@ksort($drop_down);
			while(list($key,$grant) = each($drop_down))
			{
				$form_options .= '    <option value="'.$grant['value'].'"'.($grant['grantor']==$this->bo->owner?' selected':'').'>'.$grant['name'].'</option>'."\n";
      		}
			reset($this->bo->grants);
	
			$var = Array(
//				'form_width' => $remainder,
				'form_link'	=> $this->page($referrer),
				'form_name'	=> 'owner',
				'title'	=> lang('User'),
				'hidden_vars'	=> $hidden_vars,
				'form_options'	=> $form_options,
				'button_value'	=> lang('Go!')
			);
			$tpl->set_var($var);
			$tpl->set_var('str',$tpl->fp('out','form_button_dropdown'));
			$tpl->parse('user_select','head_col',True);
//			$tpl->parse('header_column','head_col',True);
		}
	}

	$hidden_vars = '    <input type="hidden" name="from" value="'.$GLOBALS['HTTP_GET_VARS']['menuaction'].'">'."\n";

	if(isset($GLOBALS['HTTP_GET_VARS']['date']) && $GLOBALS['HTTP_GET_VARS']['date'])
	{
		$hidden_vars .= '    <input type="hidden" name="date" value="'.$GLOBALS['HTTP_GET_VARS']['date'].'">'."\n";
	}
	$hidden_vars .= '    <input type="hidden" name="month" value="'.$this->bo->month.'">'."\n";
	$hidden_vars .= '    <input type="hidden" name="day" value="'.$this->bo->day.'">'."\n";
	$hidden_vars .= '    <input type="hidden" name="year" value="'.$this->bo->year.'">'."\n";
	if(isset($this->bo->filter) && $this->bo->filter)
	{
		$hidden_vars .= '    <input type="hidden" name="filter" value="'.$this->bo->filter.'">'."\n";
	}
	$hidden_vars .= '    <input name="keywords"'.($GLOBALS['HTTP_POST_VARS']['keywords']?' value="'.$GLOBALS['HTTP_POST_VARS']['keywords'].'"':'').'>';
	$var = Array(
		'action_url_button'	=> $this->page('search'),
		'action_text_button'	=> lang('Search'),
		'action_confirm_button'	=> '',
		'action_extra_field'	=> $hidden_vars
	);
	$tpl->set_var($var);
	$button = $tpl->fp('out','form_button');
	$tpl->set_var('str',$button);
	$tpl->parse('search_box','head_col',True);
	//$tpl->parse('header_column','head_col',True);
	//$tpl->parse('row','head_table',True);
?>
