<?php
	/*****************************************************************************\
	* phpGroupWare - Forums                                                       *
	* http://www.phpgroupware.org                                                 *
	* Written by Jani Hirvinen <jpkh@shadownet.com>                               *
	* -------------------------------------------                                 *
	*  This program is free software; you	can redistribute it and/or modify it   *
	*  under the terms of	the GNU	General	Public License as published by the  *
	*  Free Software Foundation; either version 2	of the License,	or (at your *
	*  option) any later version.                                                 *
	\*****************************************************************************/

	/* $Id: index.php,v 1.25.2.1 2002/01/20 03:36:03 skeeter Exp $ */

	$phpgw_flags = Array(
		'currentapp'	=>	'chat',
		'noheader'	=>	True,
		'nonavbar'	=>	True,
		'noappheader'	=>	True,
		'noappfooter'	=>	True,
		'nofooter'	=>	False
	);

	$GLOBALS['phpgw_info']['flags'] = $phpgw_flags;
	include('../../header.inc.php');
	include('admin_channels.php');

	$tmp_dir = $GLOBALS['phpgw']->common->get_tpl_dir('chat');
	$template = CreateObject('phpgwapi.Template', $tmp_dir);
	unset($GLOBALS['phpgw_info']['flags']['noheader']);
	unset($GLOBALS['phpgw_info']['flags']['nonavbar']);
	unset($GLOBALS['phpgw_info']['flags']['noappheader']);
	unset($GLOBALS['phpgw_info']['flags']['noappfooter']);
	$GLOBALS['phpgw']->common->phpgw_header();

	// ------------- user interface routine ----------------------
	switch ($action)
	{
		case 'create':
			$template_file = 'admin_channels_create.tpl';
			break;
		case 'edit':
			$template_file = 'admin_channels_edit.tpl';
			break;
		case 'save':
			if (strlen($err_message) > 0)
				$template_file = 'admin_channels_edit.tpl';
			else
				$template_file = 'admin_channels_list.tpl';
			break;
		case 'view':
			$template_file = 'admin_channels_view.tpl';
			break;
		default:
			$template_file = 'admin_channels_list.tpl';
			break;
	}
	$template->set_file(
		Array(
			'channel_list_t'	=> $template_file
		)
	);
	if ($action != 'view')
		$template->set_block('channel_list_t','row','rows');
	for ($index = 0; $index < count($ar_channelname); $index++)
	{
		$template->set_var('ar_channelname',$ar_channelname[$index]);
		$template->set_var('channel_view_url',"$PHP_SELF?action=view&ID=".$ar_channelID[$index]);
		// phpGroupWare Admin User Check & 
		if ($GLOBALS['phpgw']->acl->check('run',1,'admin'))
		{
			$link_url = '<a href="'."$PHP_SELF?action=edit&ID=".$ar_channelID[$index].'">'.'Խ</a>';
			$template->set_var('channel_edit_url', $link_url);
			if ($ar_channelname[$index] != $ENTRYCHANNELNAME)
			{
				$link_url = '<a onClick="'."return confirm('$MSG_ADM_CHANNELS_CONFIRM_DEL')".'" href="'.
					"$PHP_SELF?action=delete&ID=".$ar_channelID[$index].'">'.lang('delete').'</a>';
				$template->set_var('channel_delete_url', $link_url);
			}
			else
			{
				$template->set_var('channel_delete_url','&nbsp;');
			}
			$link_url = '<a href="'."$PHP_SELF?action=clean&ID=".$ar_channelID[$index].'">'.'</a>';
			$template->set_var('channel_clear_url', $link_url);
		}
		else
		{
			$template->set_var('channel_edit_url','&nbsp;');
			$template->set_var('channel_delete_url','&nbsp;');
			$template->set_var('channel_clear_url','&nbsp;');
		}
		$template->fp('rows','row',True);
	}
	if ($data_moderiert == 0)
	{
		$buff1 = '<option value="1">'."$YES</option>\n";
		$buff1 .= '<option value="0" selected>'."$NO</option>\n";
	}
	else
	{
		$buff1 = '<option value="1" selected>'."$YES</option>\n";
		$buff1 .= '<option value="0">'."$NO</option>\n";
	}
	$view_data_moderiert = $data_moderiert ? $YES : $NO;
	for ($index=1; $index <= 12; $index++)
	{
    	if ($index == $data_startmonth)
			$start_month .= "<option selected>".sprintf("%02d", $index)."</option>\n";
		else
			$start_month .= "<option>".sprintf("%02d", $index)."</option>\n";
    	if ($index == $data_stopmonth)
			$end_month .= "<option selected>".sprintf("%02d", $index)."</option>\n";
		else
			$end_month .= "<option>".sprintf("%02d", $index)."</option>\n";
	}
	for ($index=1; $index <= 31; $index++)
	{
    	if ($index == $data_startday)
			$start_day .= "<option selected>".sprintf("%02d", $index)."</option>\n";
		else
			$start_day .= "<option>".sprintf("%02d", $index)."</option>\n";
    	if ($index == $data_stopday)
			$end_day .= "<option selected>".sprintf("%02d", $index)."</option>\n";
		else
			$end_day .= "<option>".sprintf("%02d", $index)."</option>\n";
	}
	for ($index=0; $index <= 23; $index++)
	{
		if ($index == $data_starthour)
			$start_hour .= "<option selected>".sprintf("%02d", $index)."</option>\n";
		else
			$start_hour .= "<option>".sprintf("%02d", $index)."</option>\n";
		if ($index == $data_stophour)
			$end_hour .= "<option selected>".sprintf("%02d", $index)."</option>\n";
		else
			$end_hour .= "<option>".sprintf("%02d", $index)."</option>\n";
	}
	for ($index=0; $index <= 59; $index++)
	{
		if ($index == $data_startminute)
			$start_minute .= "<option selected>".sprintf("%02d", $index)."</option>\n";
		else
			$start_minute .= "<option>".sprintf("%02d", $index)."</option>\n";
		if ($index == $data_startsecond)
			$start_second .= "<option selected>".sprintf("%02d", $index)."</option>\n";
		else
			$start_second .= "<option>".sprintf("%02d", $index)."</option>\n";
		if ($index == $data_stopminute)
			$end_minute .= "<option selected>".sprintf("%02d", $index)."</option>\n";
		else
			$end_minute .= "<option>".sprintf("%02d", $index)."</option>\n";
		if ($index == $data_stopsecond)
			$end_second .= "<option selected>".sprintf("%02d", $index)."</option>\n";
		else
			$end_second .= "<option>".sprintf("%02d", $index)."</option>\n";
	}
	if (!$data_ExitURL)
		$data_ExitURL = $GLOBALS['phpgw']->link('/chat/');
	$var = Array(
		'image_dir'			=> PHPGW_IMAGES,
		'image_dir2'		=> $GLOBALS['phpgw_info']['server']['webserver_url'] . '/chat/images',
		'login_url'			=> $GLOBALS['phpgw']->link('/chat/login.php'),
		'admin_channel_url'	=> $GLOBALS['phpgw']->link('/chat/admin/phpgw_admin_channels.php'),
		'action_url'		=> $GLOBALS['phpgw']->link('/chat/admin/phpgw_admin_channels.php'),
		'admin_chatter_url'	=> $GLOBALS['phpgw']->link('/chat/admin/phpgw_admin_channels.php'),
		'error_message'		=> $err_message,
		'edit_field_name'	=> $MSG_ADM_CHANNELS_FIELDS['Name'],
		'edit_field_name_value'	=> $data_Name,
		'edit_field_name_enabled'	=> ($data_Name == $ENTRYCHANNELNAME ? 'readonly' : ''),
		'edit_field_password'	=> $MSG_ADM_CHANNELS_FIELDS['PASSWORD'],
		'edit_field_password_value'	=> ($action == 'view' ? str_repeat('*',strlen($data_PASSWORD)) : $data_PASSWORD),
		'edit_field_these'	=> $MSG_ADM_CHANNELS_FIELDS['These'],
		'edit_field_these_value'	=> $data_These,
		'edit_field_teilnehmerzahl'	=> $MSG_ADM_CHANNELS_FIELDS['Teilnehmerzahl'],
		'edit_field_teilnehmerzahl_value'	=> $data_Teilnehmerzahl,
		'edit_field_bgcolor'	=> $MSG_ADM_CHANNELS_FIELDS['BG_Color'],
		'edit_field_bgcolor_value'	=> $data_BG_Color,
		'edit_field_nick_color'	=> $MSG_ADM_CHANNELS_FIELDS['NICK_COLOR'],
		'edit_field_nick_color_value'	=> $data_NICK_COLOR,
		'edit_field_logo'	=> $MSG_ADM_CHANNELS_FIELDS['Logo'],
		'edit_field_logo_value'	=> $data_Logo,
		'edit_field_exiturl'	=> $MSG_ADM_CHANNELS_FIELDS['ExitURL'],
		'edit_field_exiturl_value'	=> $data_ExitURL,
		'edit_field_moderiert'	=> $MSG_ADM_CHANNELS_FIELDS['moderiert'],
		'edit_field_moderiert_value'	=> ($action == 'view' ? $view_data_moderiert : $buff1),
		'edit_field_start_at'	=> $MSG_ADM_CHANNELS_FIELDS['starts_at'],
		'edit_field_end_at'		=> $MSG_ADM_CHANNELS_FIELDS['stops_at'],
		'edit_field_start_year_value'	=> $data_startyear,
		'edit_field_start_month_value'	=> ($action == 'view' ? $data_startmonth : $start_month),
		'edit_field_start_day_value'	=> ($action == 'view' ? $data_startday : $start_day),
		'edit_field_start_hour_value'	=> ($action == 'view' ? $data_starthour : $start_hour),
		'edit_field_start_minute_value'	=> ($action == 'view' ? $data_startminute : $start_minute),
		'edit_field_start_second_value'	=> ($action == 'view' ? $data_startsecond : $start_second),
		'edit_field_end_year_value'		=> $data_stopyear,
		'edit_field_end_month_value'	=> ($action == 'view' ? $data_stopmonth : $end_month),
		'edit_field_end_day_value'		=> ($action == 'view' ? $data_stopday : $end_day),
		'edit_field_end_hour_value'		=> ($action == 'view' ? $data_stophour : $end_hour),
		'edit_field_end_minute_value'	=> ($action == 'view' ? $data_stopminute : $end_minute),
		'edit_field_end_second_value'	=> ($action == 'view' ? $data_stopsecond : $end_second),
		'id_value'						=> $ID,
		'lang_save'		=> $MSG_ADM_SAVE,
		'lang_add_channel'	=> $MSG_ADM_NEWCHANNEL,
	);
	$template->set_var($var);
	$template->pfp('out','channel_list_t');
	//------------------------------------------------------------
	$GLOBALS['phpgw']->common->phpgw_exit(true);
?>
