<?php
  /**************************************************************************\
  * phpGroupWare module (File Manager)                                       *
  * http://www.phpgroupware.org                                              *
  * Written by Dan Kuykendall <dan@kuykendall.org>                           *
  * --------------------------------------------                             *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/

#    filemanager by Lacey Pevey
#    v0.02 - 1999/12/05 13:46 CST
#
#    You are free to use and distribute this code provided this tiny
#    header is included. No warranties, fitness for purpose, etc. etc.
#
#    Please send comments/bugfixes/enhancements to
#    lpevey@mailhost.tcs.tulane.edu.

	/* $Id: index.php,v 1.34.2.1 2002/01/15 20:51:55 seek3r Exp $ */

	$GLOBALS['phpgw_info']['flags'] = array(
		'currentapp'           => 'filemanager',
		'enable_browser_class' => True,
		'noheader'             => True
	);
	include('../header.inc.php');

	/* Use app vfs class */
	$GLOBALS['phpgw']->vfs = CreateObject('filemanager.vfs');

	$action    = $GLOBALS['HTTP_POST_VARS']['action'];
	$download  = $GLOBALS['HTTP_POST_VARS']['download'];
	$actiondir = $GLOBALS['HTTP_POST_VARS']['actiondir'];
	$pwd       = $GLOBALS['HTTP_POST_VARS']['pwd'];
	$fn        = $GLOBALS['HTTP_POST_VARS']['fn'];
	$exit      = $GLOBALS['HTTP_POST_VARS']['exit'];
	$edit      = $GLOBALS['HTTP_POST_VARS']['edit'];
	$save      = $GLOBALS['HTTP_POST_VARS']['save'];
	$copy      = $GLOBALS['HTTP_POST_VARS']['copy'];
	$rename    = $GLOBALS['HTTP_POST_VARS']['rename'];
	$newfile   = $GLOBALS['HTTP_POST_VARS']['newfile'];
	$newname   = $GLOBALS['HTTP_POST_VARS']['newname'];
	$oldname   = $GLOBALS['HTTP_POST_VARS']['oldname'];
	$delete    = $GLOBALS['HTTP_POST_VARS']['delete'];
	$upload    = $GLOBALS['HTTP_POST_VARS']['upload'];
	$contents  = $GLOBALS['HTTP_POST_VARS']['contents'];
	$start     = $GLOBALS['HTTP_POST_VARS']['start'];


//	if ($GLOBALS['phpgw_info']['server']['template_set'] == 'savant')
//	{
		$template = $GLOBALS['phpgw']->template;
		
		$GLOBALS['phpgw']->vfs->verifydir();
		$GLOBALS['phpgw']->vfs->cd('/');
				
		$GLOBALS['phpgw']->common->phpgw_header();
			
		if (!empty($exit))
		{
			unset($edit);
			unset($upload);
		}
		
		if (empty($currentdir))
		{
			$data = $GLOBALS['phpgw']->session->appsession('session_data','filemanager');
			if ($data)
				$currentdir = $data;
		}
		
		if (empty($pwd))
		{
			$pwd = '/';
		}
		if (empty($actiondir))
		{
			$actiondir = $currentdir;
		}

		$action_url = $GLOBALS['phpgw']->link('/filemanager/index.php');
		$action_ur2 = $GLOBALS['phpgw']->link('/filemanager/index2.php');		
		if ($action == 'upload' && $userfile_name)
		{
            // Modified By Kazuya Nouchi POPCOM INC 2002/12/19
            if ($userfile_size > 0)
                $GLOBALS['phpgw']->vfs->mv($userfile,"$actiondir$pwd$userfile_name",True);
            else
            {
			     $template->set_file(array('error_t' => 'upload_err.tpl'));
			     $tpl_vars = Array(
                    'image_dir'	    => PHPGW_IMAGES,
				    'action_url'	=> $action_url,
				    'action_url2'	=> $action_url2,
				    'file_name'		=> $userfile_name,
                    'post_url'      => $action_url2
			     );
			     $template->set_var($tpl_vars);
			     $template->pfp('out','error_t');
			     $GLOBALS['phpgw']->common->phpgw_footer();
			     exit;
            }
			//$GLOBALS['phpgw']->vfs->mv($userfile,"$actiondir$pwd$userfile_name",True);
            //--------------------------------------------------------------------------
		}
		$file = "$actiondir$pwd$fn";
		if ($action == 'edit' && $save)
		{
			if ((isset($file)) && (isset($contents)))
			{
				$contents = stripslashes(rtrim($contents));
				$GLOBALS['phpgw']->vfs->write($file, $contents);
			}
			else
			{
				$errmsg = lang('Error saving file to disk');
			}
		}
		else if ($action == 'copy' && $copy)
		{
			if (isset($newname) && $newname != $oldname)
			{
				if (!$GLOBALS['phpgw']->vfs->cp($actiondir.'/'.$oldname,$actiondir.'/'.$newname))
					$errmsg = lang('Error copy file to disk');
				else
					unset($file);
			}
			else
				$errmsg = lang('Error copy file to disk');	
		}
		else if ($action == 'rename' && $rename)
		{
			if (!$GLOBALS['phpgw']->vfs->mv("$actiondir$pwd$oldname","$actiondir$pwd$newname"))
				$errmsg = lang('Error rename file to disk');
			else
			{
				// Modified By Kazuya Nouchi 2002/2/23
				//$fn = $newname;
				//$file = "$actiondir$pwd$fn";
				unset($file);
				// ----------------------------------
			}
		}
		else if ($action == 'delete' && $delete)
		{
			if (!$GLOBALS['phpgw']->vfs->rm($file))
				$errmsg = lang('Error delete file to disk');
			else
				unset($file);
		}
		
		if (isset($action) && $action != 'upload' && isset($file))
		{			
			$template->set_file(array('view_t' => $action . '.tpl'));
			$modified_date = filemtime($GLOBALS['phpgw']->vfs->getabsolutepath($file));
			$dateformat = $GLOBALS['phpgw_info']['user']['preferences']['common']['dateformat'];
			$time = $GLOBALS['phpgw']->common->formattime(date('H',$modified_date),
								date('i',$modified_date), date('s',$modified_date));

			$tpl_vars = Array(
				'image_dir'			=> PHPGW_IMAGES,
				'action_url'		=> $action_url,
				'action_url2'		=> $action_ur2,
				'file_name'			=> $fn,
				'modified_date'		=> date($dateformat,$modified_date) . ' ' . $time,
				'file_size'			=> number_format(filesize($GLOBALS['phpgw']->vfs->getabsolutepath($file))),
				'content'			=> $contents = $GLOBALS['phpgw']->vfs->read($file),
				'file_type'			=> $GLOBALS['phpgw']->vfs->get_file_type($fn),
				'actiondir_value'	=> $GLOBALS['phpgw']->vfs->pwd().$actiondir,
				'pwd_value'			=> $pwd,
				'error_message'		=> $errmsg,
				'newfile_name'		=> ($newname && !$errmsg ? $newname : $fn),
				'close_url'			=> $action_ur2
			);
			$template->set_var($tpl_vars);			
			//-------------------------------------------
			$template->pfp('out','view_t');
			$GLOBALS['phpgw']->common->phpgw_footer();
			exit;				
		}
		$nextmatchs = CreateObject('phpgwapi.nextmatchs');
		$template->set_file(array('index_t' => 'index2.tpl'));
		$template->set_block('index_t','file_list','list');
					
		$dirs = $GLOBALS['phpgw']->vfs->ls();
		$dir_count = count($dirs);
		$total_num = 0;
		$total_size = 0;
		for ($diridx=0;$diridx<$dir_count;++$diridx)
		{
			if ($dirs[$diridx]['type'] == 'dir')
			{
				if ($dirs[$diridx]['name'] == 'home')
				{
					if (strtolower(substr($GLOBALS['phpgw_info']['user']['userid'],-1,1)) != 's')
					{
						$apos = "'s";
					}
					else
					{
						$apos = "'";
					}
					$dirname = $GLOBALS['phpgw_info']['user']['userid'] . $apos .lang('private_files');
				}
				else
				{
					$dirname = $dirs[$diridx]['name'].' '.lang('group_files');
				}
				if ($currentdir == $dirs[$diridx]['name'])
				{
					$temp = '<OPTION VALUE="'.$dirs[$diridx]['name'].'"'." selected>$dirname</OPTION>";
					$GLOBALS['phpgw']->session->appsession('session_data','filemanager',$dirs[$diridx]['name']);
				}				
				else
					$temp = '<OPTION VALUE="'.$dirs[$diridx]['name'].'"'.">$dirname</OPTION>";
				$dirname_list .= $temp;
				$files = $GLOBALS['phpgw']->vfs->ls($GLOBALS['phpgw']->vfs->pwd().$dirs[$diridx]['name']);
				if (!empty ($files) && $currentdir == $dirs[$diridx]['name'])
				{
					$file_count = count($files);
					for ($fileidx=0;$fileidx<$file_count;++$fileidx)
					{
						if ($files[$fileidx]['type'] == 'file')
						{
							$dateformat = $GLOBALS['phpgw_info']['user']['preferences']['common']['dateformat'];
							$time = $GLOBALS['phpgw']->common->formattime(date('H',$files[$fileidx]['modified']),
								date('i',$files[$fileidx]['modified']), date('s',$files[$fileidx]['modified']));
							$fname = $files[$fileidx]['name'];
							$rows[] = array(
								'file_name' 	=> $files[$fileidx]['name'],
								// Modified By Kazuya Nouchi POPCOM INC 2002/12/11
								'view_link'		=> $fname,
//								'view_link'		=> ($files[$fileidx]['ext_type'] == 'text/plain' ? "<a href=\"javascript:maintenance_link('view','$fname')\">$fname</a>" : $fname),
								//------------------------------------------------------------
								'modify_date'	=> date($dateformat,$files[$fileidx]['modified']) . ' ' . $time,
								'lang_modify' 	=> ($files[$fileidx]['ext_type'] == 'text/plain' ? lang('edit') : ''),
//								'lang_modify' 	=> ($files[$fileidx]['ext_type'] == lang('text') ? lang('edit') : ''),
                                // Added By Kazuya Nouchi POPCOM INC 2002/12/19
                                'file_size'	    => number_format($files[$fileidx]['size']),
                                //-------------------------------------------------------------------------------
							);
							$total_num++;
							$total_size += $files[$fileidx]['size'];
						}
					}
				}
			}
		}

		$left = $nextmatchs->left('/filemanager/index2.php',$start,$total_num);					
		$right = $nextmatchs->right('/filemanager/index2.php',$start,$total_num);
		if (!isset($start)) $start=0;
		for ($fileidx=$start,$rowctr=1;$fileidx<$total_num;++$fileidx,++$rowctr)
		{
			if ($rowctr > $GLOBALS['phpgw_info']['user']['preferences']['common']['maxmatchs'])
				break;
			$template->set_var($rows[$fileidx]);
			$template->fp('list','file_list',True);
		}				
		$tpl_vars = Array(
			'image_dir'			=> PHPGW_IMAGES,
			'dirname_list'		=> $dirname_list,
			'action_url'		=> $action_url,
			'action_ur2'		=> $action_url2,
			'actiondir_value'	=> $GLOBALS['phpgw']->vfs->pwd().$actiondir,
			'pwd_value'			=> $pwd,
			'total_num'			=> $total_num,
			'total_size'		=> number_format($total_size / 1024),
			'left'				=> $left,
			'right'				=> $right
		);
		$template->set_var($tpl_vars);			
		//-------------------------------------------
		$template->pfp('out','index_t');
		
		if (isset($currentdir))
		{
			$GLOBALS['phpgw']->vfs->cd($currentdir);
		}
		$GLOBALS['phpgw']->common->phpgw_footer();	
//	}
?>	
	
	
