<?php
	class uiqmailadmin
	{
		var $public_functions = array(
			'list_users'  	=> True,
			'add_user'    	=> True,
			'delete_user' 	=> True,			
			'edit_user'   	=> True,
			'view_user'   	=> True,
			'list_domain'	=> True,
			'add_domain'	=> True,
			'delete_domain'	=> True,
			'view_domain'	=> True,
			'edit_domain'	=> True,				
		);
		var $nextmatchs;
		var $db;
		var $domain;
		var $mail_type;
		var $mail_port;
		var $error_msg;
		var $domain_list;
		
		function uiqmailadmin()
		{
			$this->nextmatchs = createobject('phpgwapi.nextmatchs');	
			@set_time_limit(300);
			$this->domain = $GLOBALS['HTTP_POST_VARS']['domain'] ? $GLOBALS['HTTP_POST_VARS']['domain'] : $GLOBALS['HTTP_GET_VARS']['domain'];
			if (!$this->domain)
				$this->domain = $GLOBALS['phpgw_info']['server']['mail_suffix'];
			$this->db=$GLOBALS['phpgw']->db;
			$this->db->Link_ID =0;
			$this->mail_type=$GLOBALS['phpgw_info']['server']['mail_server_type'];
			switch ($this->mail_type)
			{
				case 'pop3':
					$this->mail_port=(isset($GLOBALS['phpgw_info']['server']['mail_port'])?$GLOBALS['phpgw_info']['server']['mail_port']:'110');
					break;
				case 'imap':
					$this->mail_port=(isset($GLOBALS['phpgw_info']['server']['mail_port'])?$GLOBALS['phpgw_info']['server']['mail_port']:'143');
					break;
				case 'pop3s':
					$this->mail_port=(isset($GLOBALS['phpgw_info']['server']['mail_port'])?$GLOBALS['phpgw_info']['server']['mail_port']:'995');
					break;
				case 'imaps':
					$this->mail_port=(isset($GLOBALS['phpgw_info']['server']['mail_port'])?$GLOBALS['phpgw_info']['server']['mail_port']:'993');
					break;
				default:	
					$this->mail_port=(isset($GLOBALS['phpgw_info']['server']['mail_port'])?$GLOBALS['phpgw_info']['server']['mail_port']:'110');
			}
			$this->error_msg = array(
				lang("VA_SUCCESS"),
				lang("VA_ILLEGAL_USERNAME"),
				lang("VA_USERNAME_EXISTS"),
				lang("VA_BAD_DIR"),
				lang("VA_BAD_U_DIR"),
				lang("VA_BAD_D_DIR"),
				lang("VA_BAD_V_DIR"),
				lang("VA_EXIST_U_DIR"),
				lang("VA_BAD_U_DIR2"),
				lang("VA_SUBDIR_CREATION"),
				lang("VA_USER_DOES_NOT_EXIST"),
				lang("VA_DOMAIN_DOES_NOT_EXIST"),
				lang("VA_INVALID_DOMAIN_NAME"),
				lang("VA_DOMAIN_ALREADY_EXISTS"),
				lang("VA_COULD_NOT_MAKE_DOMAIN_DIR"),
				lang("VA_COULD_NOT_OPEN_QMAIL_DEFAULT"),
				lang("VA_CAN_NOT_MAKE_DOMAINS_DIR"),
				lang("VA_COULD_NOT_UPDATE_FILE"),
				lang("VA_CRYPT_FAILED"),
				lang("VA_COULD_NOT_OPEN_DOT_QMAIL"),
				lang("VA_BAD_CHAR"),
				lang("VA_SQWEBMAIL_PASS_FAIL"),
				lang("VA_BAD_UID"),
				lang("VA_NO_AUTH_CONNECTION"),
				lang("VA_MEMORY_ALLOC_ERR"),
				lang("VA_USER_NAME_TOO_LONG"),
				lang("VA_DOMAIN_NAME_TOO_LONG"),
				lang("VA_PASSWD_TOO_LONG"),
				lang("VA_GECOS_TOO_LONG"),
				lang("VA_QUOTA_TOO_LONG"),
				lang("VA_DIR_TOO_LONG"),
				lang("VA_CLEAR_PASSWD_TOO_LONG"),
				lang("VA_ALIAS_LINE_TOO_LONG"),
				lang("VA_NULL_POINTER"),
				lang("VA_INVALID_EMAIL_CHAR")
			);
		}
		
		function account_row_action($action,$type,$account_id)
		{
			return '<a href="'.$GLOBALS['phpgw']->link('/index.php',Array(
				'menuaction' => 'admin.uiqmailadmin.'.$action.'_'.$type,
				'account_id' => $account_id,
				'domain'	=> $this->domain,
			)).'"> '.lang($action).' </a>';
		}
		
		function domain_row_action($action,$type,$domain)
		{
			return '<a href="'.$GLOBALS['phpgw']->link('/index.php',Array(
				'menuaction' => 'admin.uiqmailadmin.'.$action.'_'.$type,
				'domain'	=> $domain,
			)).'"> '.lang($action).' </a>';			
		}
		
		function get_alldomains($link_id, $search='', $start='')
		{
			if (!$link_id) return False;
			$sql = "select pw_domain,count(pw_domain) as num_users from vpopmail";
			if ($search)
				$sql .= " where pw_domain LIKE '%$search%'";
			$sql .= " group by pw_domain order by pw_domain asc";
			if (is_int($start))
				$this->db->limit_query($sql, $start);
			else
				$this->db->query($sql);
			unset($this->domain_list);
			while ($this->db->next_record())
			{
				$this->domain_list[] = array(
					'pw_domain'	=> $this->db->f('pw_domain'),
					'num_users'	=> $this->db->f('num_users')
				);
			}
		}
		
		function get_userinfo($id)
		{
			if (!$id)
				return False;
			$sql="select * from vpopmail where pw_name='".$id."' and pw_domain='".$this->domain."';";
			$link_id=$this->db->connect('vpopmail');
			if ($this->db->num_rows($this->db->query($sql)) != 1)
			{
				$this->db->free();
				$this->db->disconnect();
				$link_id=$this->db->connect('phpgroupware');
				return False;
			}
			$this->db->next_record();
			$userinfo = Array(
				'id'		=> $this->db->f('pw_name'),
				'name'		=> $this->db->f('pw_gecos'),
				'maildir'	=> $this->db->f('pw_dir'),
//				'quota'		=> (string)(intVal($this->db->f('pw_shell'))/1024/1024)
			);
			if (strpos($this->db->f('pw_shell'),'M'))
				$userinfo['quota'] = (string)intVal($this->db->f('pw_shell'));
			else
				$userinfo['quota'] = (string)(intVal($this->db->f('pw_shell'))/1024/1024);
			$sql="select remote_ip,timestamp from lastauth where user='".$id."' and domain='".$this->domain."';";
			if ($this->db->num_rows($this->db->query($sql)) != 1)
			{
				$this->db->free();
				$this->db->disconnect();
				$link_id=$this->db->connect('phpgroupware');
				return $userinfo;
			}
			$this->db->next_record();
			$userinfo['remote_ip'] = $this->db->f('remote_ip');
			$userinfo['date_yyyy'] = date("Y", $this->db->f('timestamp'));
			$userinfo['date_mm'] = date("m", $this->db->f('timestamp'));
			$userinfo['date_dd'] = date("d", $this->db->f('timestamp'));
			$userinfo['date_hh'] = date("H", $this->db->f('timestamp'));
			$userinfo['date_nn'] = date("i", $this->db->f('timestamp'));
			$userinfo['date_ss'] = date("s", $this->db->f('timestamp'));
			$this->db->free();
			$this->db->disconnect();
			$link_id=$this->db->connect('phpgroupware');
			return $userinfo;			
		}
		
		function isValidation(&$data)
		{
			$errcount=0;
			if (strlen($data['account_id']) == 0)
				$err_msg[$errcount++] = lang('qmailadmin_account_id_errmsg1');
			if (strlen($data['account_quota']) != 0 && !is_numeric($data['account_quota']))
				$err_msg[$errcount++] = lang('qmailadmin_account_quota_errmsg1');
			else if (strlen($data['account_quota'])==0 || $data['account_quota']=='0')
				$data['account_quota'] = 'NOQUOTA';
			else
				$data['account_quota'] = $data['account_quota'].'M';						
//				$data['account_quota'] = (string)(intVal($data['account_quota']) * 1024 * 1024);						
			/*
			if (vpopmail_auth_user($data['account_id'],$this->domain,$data['account_passwd']))
			{
				$err_msg[$errcount++] = vpopmail_error();
			}
			*/

			if ($errcount==0)
				return False;
			else
				return $err_msg;
		}
		
		function list_users($param_cd='')
		{
			if($param_cd)
			{
				$cd = $param_cd;
			}
			$search = (isset($GLOBALS['HTTP_POST_VARS']['query'])?$GLOBALS['HTTP_POST_VARS']['query']:'');
			$start = (isset($GLOBALS['HTTP_POST_VARS']['start'])?intval($GLOBALS['HTTP_POST_VARS']['start']):'');
			$sort=(isset($GLOBALS['HTTP_GET_VARS']['sort'])?$GLOBALS['HTTP_GET_VARS']['sort']:'');
			$order=(isset($GLOBALS['HTTP_GET_VARS']['sort'])?$GLOBALS['HTTP_GET_VARS']['order']:'');
			$link_id=$this->db->connect('vpopmail');
			$this->get_alldomains($link_id);
			$sql="select pw_name,pw_gecos from vpopmail where pw_domain='".$this->domain."'";
			if (strlen($search) > 0)
				$sql .= " and (pw_name LIKE '%$search%' OR pw_gecos LIKE '%$search%')";
			if (strlen($sort) > 0 && strlen($order) > 0)
			{
				$sql .= " order by $order $sort";
			}
			$this->db->limit_query($sql, $start);
			while ($this->db->next_record())
			{
				$accounts[] = Array(
					'account_id'        => $this->db->f('pw_name'),
					'account_name'		=> $this->db->f('pw_gecos')
				);
			}
			$sql = "select count(*) as ctr from vpopmail where pw_domain='".$this->domain."'";
			$this->db->query($sql);
			$this->db->next_record();
			$total=$this->db->f('ctr');
			$this->db->free();
			$this->db->disconnect();
			$link_id=$this->db->connect('phpgroupware');
					
			$start = (isset($GLOBALS['HTTP_POST_VARS']['start'])?intval($GLOBALS['HTTP_POST_VARS']['start']):'');
			
			unset($GLOBALS['phpgw_info']['flags']['noheader']);
			unset($GLOBALS['phpgw_info']['flags']['nonavbar']);
			$GLOBALS['phpgw']->common->phpgw_header();

			$p = CreateObject('phpgwapi.Template',PHPGW_APP_TPL);

			$p->set_file(
				Array(
					'qmailadmin' => 'qmailadmin_user_list.tpl'
				)
			);
			$p->set_block('qmailadmin','list','list');
			$p->set_block('qmailadmin','row','row');
			$p->set_block('qmailadmin','row_empty','row_empty');
			
			foreach ($this->domain_list as $val)
			{
				$pw_domain = $val['pw_domain'];
				$selected = ($pw_domain == $this->domain ? 'selected' : '');
				$domain_list .= "<option $selected value=\"$pw_domain\">$pw_domain</option>\n";
			}
			$url = $GLOBALS['phpgw']->link('/index.php','menuaction=admin.uiqmailadmin.list_users');
			
			$var = Array(
				'lang_email_accounts' 	=> lang('email accounts', $this->domain),
				'lang_accountid'		=> $this->nextmatchs->show_sort_order($sort,'pw_name',$order,$url,lang('email accountid')),
				'lang_comment' => $this->nextmatchs->show_sort_order($sort,'pw_gecos',$order,$url,lang('email accountcomment')),
				'left_next_matchs'   => $this->nextmatchs->left($url,$start,$total,'menuaction=admin.uiqmailadmin.list_users'),
				'right_next_matchs'  => $this->nextmatchs->right($url,$start,$total,'menuaction=admin.uiqmailadmin.list_users'),				
				'lang_edit'    	=> lang('edit'),
				'lang_delete'  	=> lang('delete'),
				'lang_view'    	=> lang('view'),
				'actionurl'    	=> $GLOBALS['phpgw']->link('/index.php','menuaction=admin.uiqmailadmin.add_user'),
				'accounts_url' 	=> $url,
				'lang_search'  	=> lang('search'),
				'image_dir'		=> PHPGW_IMAGES,
				'domain_list'	=> $domain_list,
				'domain_url'	=> $GLOBALS['phpgw']->link('/index.php','menuaction=admin.uiqmailadmin.list_domain'),
				'domain_selected'	=> $this->domain,
			);	
			$p->set_var($var);
			
			$p->set_var('input_add','<input type="submit" value="' . lang('qmailadmin_account_address_item').lang('Add') . '">');
			
			$p->set_var('input_search','<input type="text" name="query">');
			
			if (count($accounts) == 0)
			{
				$p->set_var('message',lang('No matchs found'));
				$p->parse('rows','row_empty',True);
			}
			else
			{
				foreach($accounts as $account)
				{
					$this->nextmatchs->template_alternate_row_color($p);
					$var = array(
						'row_accountid'	=> $account['account_id'],
						'row_comment'	=> $account['account_name']
					);		
					$p->set_var($var);
					$p->set_var('row_edit',$this->account_row_action('edit','user',$account['account_id']));
					$p->set_var('row_view',$this->account_row_action('view','user',$account['account_id']));
					$p->set_var('row_delete',($account['account_id'] != 'postmaster'?$this->account_row_action('delete','user',$account['account_id']):'&nbsp'));
	
					$p->parse('rows','row',True);
				}
			}
			$p->pfp('out','list');
		}
		
		function view_user()
		{
			if (!$GLOBALS['HTTP_GET_VARS']['account_id'])
			{
				$this->list_users();
				return False;		
			}
			unset($GLOBALS['phpgw_info']['flags']['noheader']);
			unset($GLOBALS['phpgw_info']['flags']['nonavbar']);
			$GLOBALS['phpgw']->common->phpgw_header();

			$t = CreateObject('phpgwapi.Template',PHPGW_APP_TPL);
			$t->set_unknowns('remove');
			$t->set_file(
				Array(
					'qmailadmin' => 'qmailadmin_user_form.tpl'
				)
			);
			$t->set_block('qmailadmin','form','form');
			$account = $this->get_userinfo($GLOBALS['HTTP_GET_VARS']['account_id']);
			$url = $GLOBALS['phpgw']->link('/index.php','menuaction=admin.uiqmailadmin.list_users&domain='.$this->domain);

			$var = Array(
				'lang_goback_url'	=> $url,
				'lang_title'	=> lang('qmailadmin_view_title',$this->domain),
				'lang_account_id_item'		=> lang('qmailadmin_account_id_item'),	
				'form_account_id_info'		=> $GLOBALS['HTTP_GET_VARS']['account_id'],
				'lang_account_address_item'	=> lang('qmailadmin_account_address_item'),
				'form_account_address_info'	=>  $GLOBALS['HTTP_GET_VARS']['account_id'].'@'.$this->domain,
				'lang_account_name_item'	=> lang('qmailadmin_account_name_item'),
				'form_account_name_info'	=> $account['name'],
				'lang_account_passwd_item'	=> lang('qmailadmin_account_passwd_item'),
				'form_account_passwd_info'	=> lang('qmailadmin_account_passwd_value'),
				'lang_passwd_help'	=> lang('qmailadmin_account_passwd_help'),
				'lang_account_maildir_item'	=> lang('qmailadmin_account_mairdir_item'),
				'lang_account_maildir_value'	=> $account['maildir'],
				'lang_account_quota_item'	=> lang('qmailadmin_account_quota_item'),
				'form_account_quota_info'	=> $account['quota'],
				'lang_quota_msg1'			=> lang('qmailadmin_account_quota_msg1'),
				'lang_account_remoteip_item'	=> lang('qmailadmin_account_remoteip_item'),
				'lang_account_remoteip_value'	=> $account['remote_ip'],
				'lang_account_timestamp_item'	=> lang('qmailadmin_account_timestamp_item'),
				'lang_account_timestamp_value'	=> lang('qmailadmin_account_timestamp_value',$account['date_yyyy'],
													$account['date_mm'],$account['date_dd'],$account['date_hh'],
													$account['date_nn'],$account['date_ss']),
				'image_dir'		=> PHPGW_IMAGES,
				'domain_url'	=> $GLOBALS['phpgw']->link('/index.php','menuaction=admin.uiqmailadmin.list_domain')
			);	
			$t->set_var($var);
			$t->pfp('out','form');
		}
		
		function edit_user()
		{			
			if (!$GLOBALS['HTTP_GET_VARS']['account_id'])
			{
				$this->list_users();
				return False;		
			}
			$errors=False;

			$account = $this->get_userinfo($GLOBALS['HTTP_GET_VARS']['account_id']);
				
			unset($GLOBALS['phpgw_info']['flags']['noheader']);
			unset($GLOBALS['phpgw_info']['flags']['nonavbar']);
			$GLOBALS['phpgw']->common->phpgw_header();
			
			$t = CreateObject('phpgwapi.Template',PHPGW_APP_TPL);
			$t->set_unknowns('remove');
			$t->set_file(
				Array(
					'qmailadmin' => 'qmailadmin_user_form.tpl'
				)
			);
			$t->set_block('qmailadmin','form','form');
			$t->set_block('qmailadmin','form_account_name_info','form_account_name_info');
			$t->set_block('qmailadmin','form_account_passwd_info','form_account_passwd_info');
			$t->set_block('qmailadmin','form_account_quota_info','form_account_quota_info');
			$t->set_block('qmailadmin','form_button','form_button');
			$form_url = 'http://' . $GLOBALS['phpgw_info']['server']['hostname'] . '/cgi-bin/savant.cgi?mode=vedituser';		
			$url = $GLOBALS['phpgw']->link('/index.php','menuaction=admin.uiqmailadmin.list_users&domain='.$this->domain);
			$errors = (@isset($GLOBALS['HTTP_GET_VARS']['errno']) ? array($this->error_msg[$GLOBALS['HTTP_GET_VARS']['errno']]) : False);

			$var = Array(
				'th_bg'        	=> $GLOBALS['phpgw_info']['theme']['th_bg'],
				'tr_color'		=> $GLOBALS['phpgw_info']['theme']['row_off'],
				'lang_post_url' => $form_url,
				'lang_goback_url'	=> $url,
				'redirect_url'	=> 'http://' . $GLOBALS['phpgw_info']['server']['hostname'] .
					$GLOBALS['phpgw']->link('/index.php','menuaction=admin.uiqmailadmin.edit_user&account_id='.
					$GLOBALS['HTTP_GET_VARS']['account_id'].'&domain='.$this->domain),
				'domain_value'	=> $this->domain,			
				'lang_title'	=> lang('qmailadmin_update_title',$this->domain),
				'error_messages' => (!$errors ? '' : $errors[0]),
				'lang_account_id_item'		=> lang('qmailadmin_account_id_item'),
				'form_account_id_info'		=> '<input type="hidden" name="account_id" value="'.
					$GLOBALS['HTTP_GET_VARS']['account_id'].'">'.$GLOBALS['HTTP_GET_VARS']['account_id'],	
				'lang_account_address_item'	=> lang('qmailadmin_account_address_item'),
				'form_account_address_info'	=>  $GLOBALS['HTTP_GET_VARS']['account_id'].'@'.$this->domain,
				'lang_account_name_item'	=> lang('qmailadmin_account_name_item'),
				'lang_account_name_value'	=> $account['name'],
				'lang_account_passwd_item'	=> lang('qmailadmin_account_passwd_item'),
				'lang_passwd_help'		=> lang('qmailadmin_account_passwd_help'),
				'lang_account_maildir_item'	=> lang('qmailadmin_account_mairdir_item'),
				'lang_account_maildir_value'	=> $account['maildir'],
				'lang_account_quota_item'	=> lang('qmailadmin_account_quota_item'),
				'lang_account_quota_value'	=> $account['quota'],
				'lang_quota_msg1'			=> lang('qmailadmin_account_quota_msg1'),
				'lang_quota_msg2'			=> lang('qmailadmin_account_quota_msg2'),
				'lang_account_remoteip_item'	=> lang('qmailadmin_account_remoteip_item'),
				'lang_account_remoteip_value'	=> $account['remote_ip'],
				'lang_account_timestamp_item'	=> lang('qmailadmin_account_timestamp_item'),
				'lang_account_timestamp_value'	=> lang('qmailadmin_account_timestamp_value',$account['date_yyyy'],
													$account['date_mm'],$account['date_dd'],$account['date_hh'],
													$account['date_nn'],$account['date_ss']),
				'lang_input_button1'	=> lang('update'),
				'image_dir'		=> PHPGW_IMAGES,
				'domain_url'	=> $GLOBALS['phpgw']->link('/index.php','menuaction=admin.uiqmailadmin.list_domain')
			);

			$t->set_var($var);
			$t->pfp('out','form');			
		}
		
		function add_user()
		{
			$errors=False;
			unset($GLOBALS['phpgw_info']['flags']['noheader']);
			unset($GLOBALS['phpgw_info']['flags']['nonavbar']);
			$GLOBALS['phpgw']->common->phpgw_header();
			
			$t = CreateObject('phpgwapi.Template',PHPGW_APP_TPL);
			$t->set_unknowns('remove');
			$t->set_file(
				Array(
					'qmailadmin' => 'qmailadmin_user_form.tpl'
				)
			);
			$t->set_block('qmailadmin','form','form');
			$t->set_block('qmailadmin','form_account_id_info','form_account_id_info');
			$t->set_block('qmailadmin','form_account_address_info','form_account_address_info');
			$t->set_block('qmailadmin','form_account_name_info','form_account_name_info');
			$t->set_block('qmailadmin','form_account_passwd_info','form_account_passwd_info');
			$t->set_block('qmailadmin','form_account_quota_info','form_account_quota_info');
			$t->set_block('qmailadmin','form_button','form_button');
			
			$form_url = 'http://' . $GLOBALS['phpgw_info']['server']['hostname'] . '/cgi-bin/savant.cgi?mode=vadduser';
			$errors = (@isset($GLOBALS['HTTP_GET_VARS']['errno']) ? array($this->error_msg[$GLOBALS['HTTP_GET_VARS']['errno']]) : False);
			$redirect_url = 'http://' . $GLOBALS['phpgw_info']['server']['hostname'] . 
				$GLOBALS['phpgw']->link('/index.php','menuaction=admin.uiqmailadmin.add_user&domain='.$this->domain);
			$url = $GLOBALS['phpgw']->link('/index.php','menuaction=admin.uiqmailadmin.list_users&domain='.$this->domain);

			$javascript = 'function ChangeAccount(obj)'.'{'.
				'document.FORM1.account_address.value = obj.value;}';

			$var = Array(
				'lang_post_url' => $form_url,
				'lang_goback_url'	=> $url,
				'redirect_url'	=> $redirect_url,
				'domain_value'	=> $this->domain,
				'error_messages' => (!$errors ? '' : $errors[0]),
				'lang_javascript_function'	=> $javascript,
				'lang_title'	=> lang('qmailadmin_insert_title',$this->domain),
				'lang_account_id_item'		=> lang('qmailadmin_account_id_item'),	
				'lang_account_address_item'	=> lang('qmailadmin_account_address_item'),
				'lang_account_domain_value'	=> '@'.$this->domain,
				'lang_account_name_item'	=> lang('qmailadmin_account_name_item'),
				'lang_account_name_value'	=> $account['name'],
				'lang_account_passwd_item'	=> lang('qmailadmin_account_passwd_item'),
				'lang_passwd_help'		=> lang('qmailadmin_account_passwd_help'),
				'lang_account_maildir_item'	=> lang('qmailadmin_account_mairdir_item'),
				'lang_account_maildir_value'	=> lang('qmailadmin_account_maildir_msg1'),
				'lang_account_quota_item'	=> lang('qmailadmin_account_quota_item'),
				'lang_account_quota_value'	=> (!$errors?'10':$GLOBALS['HTTP_POST_VARS']['account_quota']),
				'lang_quota_msg1'			=> lang('qmailadmin_account_quota_msg1'),
				'lang_quota_msg2'			=> lang('qmailadmin_account_quota_msg2'),
				'lang_account_remoteip_item'	=> lang('qmailadmin_account_remoteip_item'),
				'lang_account_remoteip_value'	=> lang('qmailadmin_account_remoteip_msg1'),
				'lang_account_timestamp_item'	=> lang('qmailadmin_account_timestamp_item'),
				'lang_account_timestamp_value'	=> lang('qmailadmin_account_timespan_msg1'),
				'lang_input_button1'	=> lang('Add'),
				'image_dir'		=> PHPGW_IMAGES,
				'domain_url'	=> $GLOBALS['phpgw']->link('/index.php','menuaction=admin.uiqmailadmin.list_domain')
			);
			$t->set_var($var);
			$t->pfp('out','form');				
		}
		
		function maildir_delete(&$account)
		{
			$errors = False;
			if($this->mail_type=='pop3' || $this->mail_type=='pop3s')
			{
				$mailauth = @imap_open('{'.$GLOBALS['phpgw_info']['server']['mail_server'].'/pop3:'.$this->mail_port.'}INBOX', 
						$account['account_id'].'@'.$this->domain,$account['account_passwd'], CL_EXPUNGE);
			}
			else
			{
				$mailauth = @imap_open('{'.$GLOBALS['phpgw_info']['server']['mail_server'].':'.$this->mail_port.'}INBOX', 
						$account['account_id'].'@'.$this->domain,$account['account_passwd'], CL_EXPUNGE);
			}					
			if ($mailauth)
			{
				$msginfo=@imap_mailboxmsginfo($mailauth);
				if ($msginfo)
				{
					for($i=1;$i <= $msginfo->Nmsgs; $i++)
					{
						@imap_delete($mailauth,$i);
					}
					@imap_expunge($mailauth);
					if (strpos($this->mail_type,'imap') >= 0)
					{
						$list = @imap_listmailbox($mailauth, '{'.$GLOBALS['phpgw_info']['server']['mail_server'].':'.$this->mail_port.'}', '*');
						reset($list);
						while (list($key, $val) = each($list))
						{
							@imap_deletemailbox($mailauth, $val);
						}
					}
				}	
				@imap_close($mailauth);			
			}
			if(strpos($this->mail_type,'imap') >= 0)
			{
				$mailauth = @imap_open('{'.$GLOBALS['phpgw_info']['server']['mail_server'].':'.$this->mail_port.'}INBOX.Trash', 
					$account['account_id'].'@'.$this->domain,$account['account_passwd']);
				if ($mailauth)
				{
					$msginfo=@imap_mailboxmsginfo($mailauth);
					if ($msginfo)
					{
						for($i=1;$i <= $msginfo->Nmsgs; $i++)
						{
							@imap_delete($mailauth,$i);
						}
						@imap_expunge($mailauth);
					}
					@imap_close($mailauth);
				}
			}					
			$errors=@imap_errors();
			return $errors;
		}
		
		function delete_user()
		{
			$errors=False;
			if (!$GLOBALS['HTTP_GET_VARS']['account_id'])
			{
				$this->list_users();
				return False;		
			}

			unset($GLOBALS['phpgw_info']['flags']['noheader']);
			unset($GLOBALS['phpgw_info']['flags']['nonavbar']);
			$GLOBALS['phpgw']->common->phpgw_header();

			$t = CreateObject('phpgwapi.Template',PHPGW_APP_TPL);
			$t->set_unknowns('remove');
			$t->set_file(
				Array(
					'qmailadmin' => 'qmailadmin_user_form.tpl'
				)
			);
			$t->set_block('qmailadmin','form','form');
			$t->set_block('qmailadmin','form_button','form_button');
			$account = $this->get_userinfo($GLOBALS['HTTP_GET_VARS']['account_id']);
			$url = $GLOBALS['phpgw']->link('/index.php','menuaction=admin.uiqmailadmin.list_users&domain='.$this->domain);
			$form_url = 'http://' . $GLOBALS['phpgw_info']['server']['hostname'] . '/cgi-bin/savant.cgi?mode=vdeluser';
			$errors = (@isset($GLOBALS['HTTP_GET_VARS']['errno']) ? array($this->error_msg[$GLOBALS['HTTP_GET_VARS']['errno']]) : False);

			$var = Array(
				'lang_goback_url'	=> $url,
				'lang_post_url' => $form_url,
				'redirect_url'	=> 'http://' . $GLOBALS['phpgw_info']['server']['hostname'] . $url,
				'redirect_url1'	=> 'http://' . $GLOBALS['phpgw_info']['server']['hostname'] .
					$GLOBALS['phpgw']->link('/index.php','menuaction=admin.uiqmailadmin.delete_user&account_id='.
					$GLOBALS['HTTP_GET_VARS']['account_id'].'&domain='.$this->domain),
				'domain_value'	=> $this->domain,
				'lang_title'	=> lang('qmailadmin_delete_title',$this->domain),
				'error_messages' => (!$errors ? '' : $errors[0]),
				'lang_account_id_item'		=> lang('qmailadmin_account_id_item'),	
				'form_account_id_info'		=> '<input type="hidden" name="account_id" value="'.
					$GLOBALS['HTTP_GET_VARS']['account_id'].'">'.$GLOBALS['HTTP_GET_VARS']['account_id'],
				'lang_account_address_item'	=> lang('qmailadmin_account_address_item'),
				'form_account_address_info'	=>  $GLOBALS['HTTP_GET_VARS']['account_id'].'@'.$this->domain,
				'lang_account_name_item'	=> lang('qmailadmin_account_name_item'),
				'form_account_name_info'	=> $account['name'],
				'lang_account_passwd_item'	=> lang('qmailadmin_account_passwd_item'),
				'form_account_passwd_info'	=> lang('qmailadmin_account_passwd_value'),
				'lang_passwd_help'	=> lang('qmailadmin_account_passwd_help'),
				'lang_account_maildir_item'	=> lang('qmailadmin_account_mairdir_item'),
				'lang_account_maildir_value'	=> $account['maildir'],
				'lang_account_quota_item'	=> lang('qmailadmin_account_quota_item'),
				'form_account_quota_info'	=> $account['quota'],
				'lang_quota_msg1'			=> lang('qmailadmin_account_quota_msg1'),
				'lang_account_remoteip_item'	=> lang('qmailadmin_account_remoteip_item'),
				'lang_account_remoteip_value'	=> $account['remote_ip'],
				'lang_account_timestamp_item'	=> lang('qmailadmin_account_timestamp_item'),
				'lang_account_timestamp_value'	=> lang('qmailadmin_account_timestamp_value',$account['date_yyyy'],
													$account['date_mm'],$account['date_dd'],$account['date_hh'],
													$account['date_nn'],$account['date_ss']),
				'lang_input_button1'	=> lang('Delete'),
				'image_dir'		=> PHPGW_IMAGES,
			);	
			$t->set_var($var);
			$t->pfp('out','form');
		}
		
		function list_domain()
		{
			$search = (isset($GLOBALS['HTTP_POST_VARS']['query'])?$GLOBALS['HTTP_POST_VARS']['query']:'');
			$start = (isset($GLOBALS['HTTP_POST_VARS']['start'])?intval($GLOBALS['HTTP_POST_VARS']['start']): 0);
			
			unset($GLOBALS['phpgw_info']['flags']['noheader']);
			unset($GLOBALS['phpgw_info']['flags']['nonavbar']);
			$GLOBALS['phpgw']->common->phpgw_header();

			$p = CreateObject('phpgwapi.Template',PHPGW_APP_TPL);

			$p->set_file(
				Array(
					'qmailadmin' => 'qmailadmin_domain_list.tpl'
				)
			);
			$p->set_block('qmailadmin','list','list');
			$p->set_block('qmailadmin','row','row');
			$p->set_block('qmailadmin','row_empty','row_empty');
			
			$link_id=$this->db->connect('vpopmail');
			$this->get_alldomains($link_id, $search, $start);
			$total = count($this->domain_list);
			if ($total == 0)
			{
				$p->set_var('message',lang('No matchs found'));
				$p->parse('rows','row_empty',True);
			}
			else
			{
				$sql = "show tables from vpopmail like 'ip_alias_map'";
				$ip_alias_map_exist = ($this->db->num_rows($this->db->query($sql)) > 0 ? True : False);
				foreach ($this->domain_list as $val)
				{
					unset($ip_addr);
					if ($ip_alias_map_exist)
					{
						$sql = "select ip_addr from ip_alias_map where domain='".$val['pw_domain']."'";
						$this->db->query($sql);
						while ($this->db->next_record())
						{
							$ip_addr .= "[".$this->db->f('ip_addr')."],";
						}
						$ip_addr = substr($ip_addr, 0, strlen($ip_addr)-1);
					}
					if (strlen($ip_addr) > 0)
						$ip_addr = lang('ip based domain') . $ip_addr;
					else
						$ip_addr = lang('name based domain');					
					$var = array(
						'row_domainname'	=> $val['pw_domain'],
						'row_usercount'		=> $val['num_users'],
						'row_ipaddress'		=> $ip_addr
					);		
					$p->set_var($var);
					$p->set_var('row_view',$this->domain_row_action('view','domain',$val['pw_domain']));
					$p->set_var('row_edit',$this->domain_row_action('edit','domain',$val['pw_domain']));
					$p->set_var('row_delete',$this->domain_row_action('delete','domain',$val['pw_domain']));
					$p->parse('rows','row',True);
				}
			}
			$sql = "select count(domain)-1 as ctr from dir_control";	// except dom_6000 row data(-1)
			$this->db->query($sql);
			$this->db->next_record();
			$total = $this->db->f('ctr');
			$this->db->free();
			$this->db->disconnect();
			$link_id=$this->db->connect('phpgroupware');
			
			$url = $GLOBALS['phpgw']->link('/index.php','menuaction=admin.uiqmailadmin.list_domain');
			$var = Array(
				'image_dir'			=> PHPGW_IMAGES,
				'account_list_url'	=> $GLOBALS['phpgw']->link('/index.php','menuaction=admin.uiqmailadmin.list_users'),
				'left_next_matchs'	=> $this->nextmatchs->left($url,$start,$total,'menuaction=admin.uiqmailadmin.list_domain'),
				'right_next_matchs'	=> $this->nextmatchs->right($url,$start,$total,'menuaction=admin.uiqmailadmin.list_domain'),
				'query_url'			=> $url,
				'lang_search'		=> lang('Search'),
				'input_search'		=> '<input type="text" name="query">',
				'lang_view'			=> lang('View'),
				'lang_edit'			=> lang('Edit'),
				'lang_delete'		=> lang('Delete'),
				'input_add'			=> '<input type="submit" value="' . lang('qmailadmin_add_domain') . '">',
				'domain_add_url'	=> $GLOBALS['phpgw']->link('/index.php','menuaction=admin.uiqmailadmin.add_domain'),
			);
			$p->set_var($var);
			$p->pfp('out','list');
		}
		
		function add_domain()
		{
			unset($GLOBALS['phpgw_info']['flags']['noheader']);
			unset($GLOBALS['phpgw_info']['flags']['nonavbar']);
			$GLOBALS['phpgw']->common->phpgw_header();

			$t = CreateObject('phpgwapi.Template',PHPGW_APP_TPL);

			$t->set_file(
				Array(
					'qmailadmin' => 'qmailadmin_domain_form.tpl'
				)
			);
			$t->set_block('qmailadmin','form','form');
			$t->set_block('qmailadmin','form_domain_name_info','form_domain_name_info');
			$t->set_block('qmailadmin','form_domain_passwd_info','form_domain_passwd_info');
			$t->set_block('qmailadmin','form_domain_quota_info','form_domain_quota_info');
			$t->set_block('qmailadmin','form_domain_auth_info','form_domain_auth_info');
			$t->set_block('qmailadmin','form_button','form_button');
			$errors = (@isset($GLOBALS['HTTP_GET_VARS']['errno']) ? array($this->error_msg[$GLOBALS['HTTP_GET_VARS']['errno']]) : False);
			$redirect_url = 'http://' . $GLOBALS['phpgw_info']['server']['hostname'] . 
				$GLOBALS['phpgw']->link('/index.php','menuaction=admin.uiqmailadmin.add_domain');
			$var = Array(
				'accounts_url'	=> $GLOBALS['phpgw']->link('/index.php','menuaction=admin.uiqmailadmin.list_users'),
				'redirect_url'	=> $redirect_url,
				'error_messages' => (!$errors ? '' : $errors[0]),
				'lang_title'	=> lang('qmailadmin_add_domain_discription'),
				'lang_input_button1'	=> lang('Add'),
				'image_dir'		=> PHPGW_IMAGES,
				'domain_url'	=> $GLOBALS['phpgw']->link('/index.php','menuaction=admin.uiqmailadmin.list_domain'),
				'domain_passwd_help'	=> lang('input domain master password'),
				'lang_quota_msg1'			=> lang('qmailadmin_account_quota_msg1'),
				'lang_quota_msg2'			=> lang('qmailadmin_account_quota_msg2'),
				'domain_maildir_value'		=> lang('qmailadmin_domain_maildir_msg'),
				'domain_quota_value'		=> '10',
				'lang_post_url'	=>  'http://' . $GLOBALS['phpgw_info']['server']['hostname'] . '/cgi-bin/savant.cgi?mode=vadddomain',
			);
			$t->set_var($var);
			$t->pfp('out','form');				
		}
		
		function delete_domain()
		{
			unset($GLOBALS['phpgw_info']['flags']['noheader']);
			unset($GLOBALS['phpgw_info']['flags']['nonavbar']);
			$GLOBALS['phpgw']->common->phpgw_header();

			$t = CreateObject('phpgwapi.Template',PHPGW_APP_TPL);

			$t->set_file(
				Array(
					'qmailadmin' => 'qmailadmin_domain_form.tpl'
				)
			);
			$t->set_block('qmailadmin','form','form');	
			$t->set_block('qmailadmin','form_button','form_button');
			$errors = (@isset($GLOBALS['HTTP_GET_VARS']['errno']) ? array($this->error_msg[$GLOBALS['HTTP_GET_VARS']['errno']]) : False);
			$redirect_url = 'http://' . $GLOBALS['phpgw_info']['server']['hostname'] . 
				$GLOBALS['phpgw']->link('/index.php','menuaction=admin.uiqmailadmin.list_domain');
			$redirect_url1 = 'http://' . $GLOBALS['phpgw_info']['server']['hostname'] . 
				$GLOBALS['phpgw']->link('/index.php','menuaction=admin.uiqmailadmin.delete_domain&domain='.$this->domain);
			$userinfo = $this->get_userinfo('postmaster');
			$userinfo['maildir'] = str_replace('/postmaster','',$userinfo['maildir']);
			$var = Array(
				'image_dir'		=> PHPGW_IMAGES,
				'domain_url'	=> $GLOBALS['phpgw']->link('/index.php','menuaction=admin.uiqmailadmin.list_domain'),
				'lang_quota_msg1'			=> lang('qmailadmin_account_quota_msg1'),
				'error_messages' => (!$errors ? '' : $errors[0]),
				'redirect_url'	=> $redirect_url,
				'redirect_url1'	=> $redirect_url1,
				'lang_input_button1'	=> lang('Delete'),
				'accounts_url'	=> $GLOBALS['phpgw']->link('/index.php','menuaction=admin.uiqmailadmin.list_users'),
				'lang_post_url'	=>  'http://' . $GLOBALS['phpgw_info']['server']['hostname'] . '/cgi-bin/savant.cgi?mode=vdeldomain',
				'form_domain_passwd_info'	=> lang('qmailadmin_account_passwd_value'),
				'form_domain_name_info'		=> '<input type="hidden" name="domain_name" value="'.$this->domain.'">'.$this->domain,
				'form_domain_auth_info'		=> 'POP',
				'form_domain_quota_info'	=> $userinfo['quota'],
				'domain_maildir_value'		=> $userinfo['maildir'],
				'etc_messages'				=> lang('qmailadmin_domain_delete_confirm_msg'),
				'javascript_value'			=> 'onclick="return(Confirm())"',
				'lang_title'				=> lang('qmailadmin_del_domain_discription',$this->domain),
			);
			$t->set_var($var);
			$t->pfp('out','form');		
		}
		
		function view_domain()
		{
			unset($GLOBALS['phpgw_info']['flags']['noheader']);
			unset($GLOBALS['phpgw_info']['flags']['nonavbar']);
			$GLOBALS['phpgw']->common->phpgw_header();

			$t = CreateObject('phpgwapi.Template',PHPGW_APP_TPL);

			$t->set_file(
				Array(
					'qmailadmin' => 'qmailadmin_domain_form.tpl'
				)
			);
			$t->set_block('qmailadmin','form','form');
			$userinfo = $this->get_userinfo('postmaster');
			$userinfo['maildir'] = str_replace('/postmaster','',$userinfo['maildir']);
			$var = Array(
				'image_dir'		=> PHPGW_IMAGES,
				'domain_url'	=> $GLOBALS['phpgw']->link('/index.php','menuaction=admin.uiqmailadmin.list_domain'),
				'lang_quota_msg1'			=> lang('qmailadmin_account_quota_msg1'),
				'error_messages' => (!$errors ? '' : $errors[0]),
				'accounts_url'	=> $GLOBALS['phpgw']->link('/index.php','menuaction=admin.uiqmailadmin.list_users'),
				'form_domain_passwd_info'	=> lang('qmailadmin_account_passwd_value'),
				'form_domain_name_info'		=> $this->domain,
				'form_domain_auth_info'		=> 'POP',
				'form_domain_quota_info'	=> $userinfo['quota'],
				'domain_maildir_value'		=> $userinfo['maildir'],
				'lang_title'				=> lang('qmailadmin_view_domain_discription',$this->domain),
			);
			$t->set_var($var);
			$t->pfp('out','form');				
		}
		
		function edit_domain()
		{
			unset($GLOBALS['phpgw_info']['flags']['noheader']);
			unset($GLOBALS['phpgw_info']['flags']['nonavbar']);
			$GLOBALS['phpgw']->common->phpgw_header();

			$t = CreateObject('phpgwapi.Template',PHPGW_APP_TPL);

			$t->set_file(
				Array(
					'qmailadmin' => 'qmailadmin_domain_form.tpl'
				)
			);
			$t->set_block('qmailadmin','form','form');
			$t->set_block('qmailadmin','form_domain_passwd_info','form_domain_passwd_info');
			$t->set_block('qmailadmin','form_domain_quota_info','form_domain_quota_info');
			$t->set_block('qmailadmin','form_domain_auth_info','form_domain_auth_info');
			$t->set_block('qmailadmin','form_button','form_button');
			$userinfo = $this->get_userinfo('postmaster');
			$userinfo['maildir'] = str_replace('/postmaster','',$userinfo['maildir']);
			$errors = (@isset($GLOBALS['HTTP_GET_VARS']['errno']) ? array($this->error_msg[$GLOBALS['HTTP_GET_VARS']['errno']]) : False);
			$redirect_url = 'http://' . $GLOBALS['phpgw_info']['server']['hostname'] . 
				$GLOBALS['phpgw']->link('/index.php','menuaction=admin.uiqmailadmin.edit_domain&domain='.$this->domain);
			$var = Array(
				'image_dir'		=> PHPGW_IMAGES,
				'domain_url'	=> $GLOBALS['phpgw']->link('/index.php','menuaction=admin.uiqmailadmin.list_domain'),
				'redirect_url'	=> $redirect_url,
				'lang_quota_msg1'			=> lang('qmailadmin_account_quota_msg1'),
				'lang_quota_msg2'			=> lang('qmailadmin_account_quota_msg2'),
				'error_messages' => (!$errors ? '' : $errors[0]),
				'accounts_url'	=> $GLOBALS['phpgw']->link('/index.php','menuaction=admin.uiqmailadmin.list_users'),
				'form_domain_name_info'		=> '<input type="hidden" name="domain_name" value="'.$this->domain.'">'.$this->domain,
				'domain_quota_value'		=> $userinfo['quota'],
				'domain_maildir_value'		=> $userinfo['maildir'],
				'lang_title'				=> lang('qmailadmin_edit_domain_discription',$this->domain),
				'error_messages' => (!$errors ? '' : $errors[0]),
				'lang_input_button1'	=> lang('Edit'),
				'domain_passwd_help'	=> lang('qmailadmin_account_passwd_help'),
				'lang_post_url'	=>  'http://' . $GLOBALS['phpgw_info']['server']['hostname'] . '/cgi-bin/savant.cgi?mode=veditdomain',
			);
			$t->set_var($var);
			$t->pfp('out','form');		
		}
	}
?>