<?php
	/*****************************************************************************\
	* phpGroupWare - Forums                                                       *
	* http://www.phpgroupware.org                                                 *
	* Written by Jani Hirvinen <jpkh@shadownet.com>                               *
	* -------------------------------------------                                 *
	*  This program is free software; you	can redistribute it and/or modify it   *
	*  under the terms of	the GNU	General	Public License as published by the  *
	*  Free Software Foundation; either version 2	of the License,	or (at your *
	*  option) any later version.                                                 *
	\*****************************************************************************/

	/* $Id: index.php,v 1.25.2.1 2002/01/20 03:36:03 skeeter Exp $ */

	$phpgw_flags = Array(
		'currentapp'	=>	'chat',
		'noheader'	=>	True,
		'nonavbar'	=>	True,
		'noappheader'	=>	True,
		'noappfooter'	=>	True,
		'nofooter'	=>	False
	);

	$GLOBALS['phpgw_info']['flags'] = $phpgw_flags;
	include('../header.inc.php');
//	print session_id();
	include('index.php');
	unset($GLOBALS['phpgw_info']['flags']['noheader']);
	unset($GLOBALS['phpgw_info']['flags']['nonavbar']);
	unset($GLOBALS['phpgw_info']['flags']['noappheader']);
	unset($GLOBALS['phpgw_info']['flags']['noappfooter']);
	$GLOBALS['phpgw']->common->phpgw_header();

	$tmp_dir = $GLOBALS['phpgw']->common->get_tpl_dir('chat');
	$template = CreateObject('phpgwapi.Template', $tmp_dir);
	// ------------- user interface routine ----------------------
	$template->set_file(
		Array(
			'INDEX'	=> 'login.tpl'
		)
	);
	$var = Array(
		'image_dir'			=> PHPGW_IMAGES,
		'image_dir2'		=> $GLOBALS['phpgw_info']['server']['webserver_url'] . '/chat/images',
		'lang_chat_start'	=> $GO,
		'lang_message'		=> ($PHPOPENCHAT_USER ? "$REMOTE_USER, $hello_message." : "Hallo!"),
		'action_url'		=> $GLOBALS['phpgw']->link('/chat/login.php'),
		'lang_nickname'		=> $NICK_NAME,
		'max_nickname_length'	=> $MAX_NICK_LENGTH,
		'phpopenchat_user'	=> $PHPOPENCHAT_USER,
		'lang_password'		=> $PASSWORD,
		'entry_channels'	=> $entry_channels,
		'no_script'			=> $NO_SCRIPT,
		'register_url'		=> "phpgw_register.$FILE_EXTENSION",
		'lang_register_nick'	=> $REGISTER_NICK,
		'session_name'		=> session_name(),
		'session_id'		=> session_id(),
		'lang_num_user'		=> $NUM_USER,
		'num_reg_chatters'	=> $num_reg_chatters,
		'lang_local_time'	=> $LOCAL_TIME,
		'local_time'		=> date(" H:i",time()),
		'lang_chatters_online'	=> $CHATTERS_ONLINE,
		'online_users'		=> $online_users,
		'chatters_online_24h'	=> $CHATTERS_ONLINE_24H,
		'num_last24h_chatters'	=> $num_last24h_chatters,
		'fehler'			=> $fehler,
		'online_table'		=> $online_table,
		'main_url'			=> "main.$FILE_EXTENSION",
		'lang_my_profile'	=> $MY_PROFILE,
		'lang_toplist'		=> $TOPLIST,
		'lang_forgot_pwd'	=> $FORGOT_PWD,
		'admin_channel_url'	=> $GLOBALS['phpgw']->link('/chat/admin/phpgw_admin_channels.php'),
		'admin_chatter_url'	=> $GLOBALS['phpgw']->link('/chat/login.php'),
		'lang_channel'		=> $CHANNEL
	);
	$template->set_var($var);
	$template->parse('Out','INDEX');
	$template->p('Out');
//	print $GLOBALS['sessionid']."\n";
//	print session_id();

	//------------------------------------------------------------
	$GLOBALS['phpgw']->common->phpgw_exit(true);
?>
