<?php
	/*****************************************************************************\
	* phpGroupWare - Forums                                                       *
	* http://www.phpgroupware.org                                                 *
	* Written by Jani Hirvinen <jpkh@shadownet.com>                               *
	* -------------------------------------------                                 *
	*  This program is free software; you	can redistribute it and/or modify it   *
	*  under the terms of	the GNU	General	Public License as published by the  *
	*  Free Software Foundation; either version 2	of the License,	or (at your *
	*  option) any later version.                                                 *
	\*****************************************************************************/

	/* $Id: index.php,v 1.25.2.1 2002/01/20 03:36:03 skeeter Exp $ */

	$phpgw_flags = Array(
		'currentapp'	=>	'chat',
		'noheader'	=>	True,
		'nonavbar'	=>	True,
		'noappheader'	=>	True,
		'noappfooter'	=>	True,
		'nofooter'	=>	False
	);

	$GLOBALS['phpgw_info']['flags'] = $phpgw_flags;
	include('../header.inc.php');
	include('register.php');

	$tmp_dir = $GLOBALS['phpgw']->common->get_tpl_dir('chat');
	$template = CreateObject('phpgwapi.Template', $tmp_dir);
	unset($GLOBALS['phpgw_info']['flags']['noheader']);
	unset($GLOBALS['phpgw_info']['flags']['nonavbar']);
	unset($GLOBALS['phpgw_info']['flags']['noappheader']);
	unset($GLOBALS['phpgw_info']['flags']['noappfooter']);
	$GLOBALS['phpgw']->common->phpgw_header();

	// ------------- user interface routine ----------------------
	$template->set_file(
		Array(
			'INDEX'	=> 'register.tpl'
		)
	);
	$var = Array(
		'image_dir'			=> PHPGW_IMAGES,
		'image_dir2'		=> $GLOBALS['phpgw_info']['server']['webserver_url'] . '/chat/images',
		'login_url'			=> $GLOBALS['phpgw']->link('/chat/login.php'),
		'lang_register_title'	=> $REGISTER_TITLE,
		'register_url'		=> "phpgw_register.$FILE_EXTENSION",
		'fehler'			=> $fehler,
		'lang_nick_name'	=> $NICK_NAME,
		'max_nick_length'	=> $MAX_NICK_LENGTH,
		'entry_channels'	=> $entry_channels,
		'lang_password'		=> $PASSWORD,
		'lang_again'		=> $AGAIN,
		'lang_mail_address'	=> $MAIL_ADDRESS,
		'mail_address_add'	=> ($REGISTER_WITH_EMAIL ? $MAIL_ADDRESS_ADD : ''),
		'profil_optional'	=> $PROFIL_OPTIONAL,
		'profil_motto'		=> $PROFIL_MOTTO,
		'profil_info'		=> $PROFIL_INFO,
		'profil_show_email'	=> $PROFIL_SHOW_EMAIL,
		'lang_profil_yes'	=> $PROFIL_YES,
		'lang_profil_no'	=> $PROFIL_NO,
		'profil_show_friends'	=> $PROFIL_SHOW_FRIENDS,
		'profil_show_birthday'	=> $PROFIL_SHOW_BIRTHDATE,
		'profil_birthdate'	=> $PROFIL_BIRTHDATE,
		'profil_homepage'	=> $PROFIL_HOMEPAGE,
		'profil_hobbies'	=> $PROFIL_HOBBIES,
		'profil_iam'		=> $PROFIL_IAM,
		'profil_male'		=> $PROFIL_MALE,
		'profil_female'		=> $PROFIL_FEMALE,
		'profile_home'		=> $PROFILE_HOME,
		'profil_icq'		=> $PROFIL_ICQ,
		'profil_pic'		=> $PROFIL_PIC,
		'lang_register_submit'	=> $REGISTER_SUBMIT,
		'success'			=> $success,
		'admin_channel_url'	=> $GLOBALS['phpgw']->link('/chat/admin/phpgw_admin_channels.php'),
		'admin_chatter_url'	=> $GLOBALS['phpgw']->link('/chat/login.php'),
	);
	$template->set_var($var);
	$template->parse('Out','INDEX');
	$template->p('Out');
	//------------------------------------------------------------
	$GLOBALS['phpgw']->common->phpgw_exit(true);
?>
