<?// -*- C++ -*-
/*   ********************************************************************   **
**   Copyright (C) 2000-     PHPOpenChat Development Team                   **
**   http://www.ortelius.de/phpopenchat/                                    **
**                                                                          **
**   This program is free software. You can redistribute it and/or modify   **
**   it under the terms of the PHPOpenChat License Version 1.0              **
**                                                                          **
**   This program is distributed in the hope that it will be useful,        **
**   but WITHOUT ANY WARRANTY, without even the implied warranty of         **
**   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                   **
**                                                                          **
**   You should have received a copy of the PHPOpenChat License             **
**   along with this program.                                               **
**   ********************************************************************   */


/**
* format of the error message, which appears throughout logon
*
* @param mixed $code
* @author Michael Oertel <Michael@ortelius.de>
* @global $nick,$message
* @return string contains the error message
*/

/* 
 * Include some default values
 */
include ('defaults_inc.php');

/*
 * Open a database connection
 * The following include returns a database handle
 */
include ('connect_db_inc.php');
$db_handle=connect_db($DATABASEHOST,$DATABASEUSER,$DATABASEPASSWD);
if(!$db_handle){
  exit;//the error message is printed in connect_db_inc.php
}
include ("login_inc.php");
if($password && $password2){ //new registration
	check_register($nick,$password,$password2,$user_email,$db_handle);
  if(!$fehler){
  	//set a cookie
    $Zeit = time();
    //if we want to send an amail for konfimation, we have to set kicked to -1 (what means: not yet confirmed)
    if($REGISTER_WITH_EMAIL){
      $kicked = -1;
    }else{
      $kicked = 0;
    }
    SetCookie("PHPOPENCHAT_USER",$nick,time()+10035200);
    $result=mysql_query("DELETE FROM chat WHERE Nick='$nick'",$db_handle);
    $result=mysql_query("DELETE FROM channels WHERE Name='$nick'",$db_handle);
    $result=mysql_query("INSERT INTO chat_data (Nick,Zeit,Raum,Passwort,PictureURL,Email,Online,Host,kicked) VALUES ('$nick',$Zeit,'$channel','$password','$pictureURL','$user_email',0,'$REMOTE_ADDR',$kicked)",$db_handle);
    $birthdate = $birth_year*10000 + $birth_month*100 + $birth_day;
	$result = mysql_query("INSERT INTO chat_userpages set Gender = '$gender', Hobbies = '".strip_tags($hobbies)."', Info = '".strip_tags($info)."', Picture = 'http://".strip_tags($pic_url)."', Show_Friends = '$show_friend', Show_Birthdate = '$show_birth', Show_Email = '$show_email', Homepage='".strip_tags($homepage)."',Theme='".strip_tags($theme)."',City='".strip_tags($city)."',ICQ='".strip_tags($icq)."',Birthdate='".strip_tags($birthdate)."', Nick = '$nick'");
    $result=mysql_query("INSERT INTO chat_mail (TIME,UNREAD,NICK,SENDER,SUBJECT,BODY) VALUES (CURRENT_TIMESTAMP(),1,'$nick','$TEAM_NAME','$WELCOME_SUBJ','<!-- $nick|$TEAM_NAME|2|0|0|-->$WELCOME_MSG')",$db_handle);
    $pruef=Crypt($nick,$salt_nick);
	// Modofied By Kazuya Nouchi POPCOM INC 2002/7/28
	if (!isset($GLOBALS['sessionid']))
    	$successlink = "<a href=\"index.$FILE_EXTENSION\">";
	else
    	$successlink = "<a href=\"login.$FILE_EXTENSION\">";
	//---------------------------------------------------------------
    if($REGISTER_WITH_EMAIL){
      $salt_nick = substr(md5($nick.$pass_phrase),strlen($pass_phrase)%30,2);
      $code = Crypt($nick,$salt_nick);
	  if (!isset($GLOBALS['sessionid']))
      	$confirmation_link = 'confirm.'.$FILE_EXTENSION.'?user='.urlencode($nick).'&code='.urlencode($code);
      else
		$confirmation_link = 'phpgw_confirm.'.$FILE_EXTENSION.'?user='.urlencode($nick).'&code='.urlencode($code);
//	  $MAIL_BODY = $REGISTER_MAIL_1.$confirmation_link.$REGISTER_MAIL_2;
	  $MAIL_BODY = $REGISTER_MAIL_BODY1.sprintf($REGISTER_MAIL_BODY2,$nick).sprintf($REGISTER_MAIL_BODY3,$password)
		.sprintf($REGISTER_MAIL_BODY4,$user_email).sprintf($REGISTER_MAIL_BODY5,$gender == 'male' ? $PROFIL_MALE:$PROFIL_FEMALE)
		.sprintf($REGISTER_MAIL_BODY6,$birth_year,$birth_month,$birth_day).sprintf($REGISTER_MAIL_BODY7,$homepage)
		.sprintf($REGISTER_MAIL_BODY8,$hobbies).sprintf($REGISTER_MAIL_BODY9,$city).sprintf($REGISTER_MAIL_BODY10,$icq)
		.sprintf($REGISTER_MAIL_BODY11,$pic_url).sprintf($REGISTER_MAIL_BODY12,$show_email != 0 ? $PROFIL_YES : $PROFIL_NO)
		.sprintf($REGISTER_MAIL_BODY13,$show_friend != 0 ? $PROFIL_YES : $PROFIL_NO).sprintf($REGISTER_MAIL_BODY14,$show_birth != 0 ? $PROFIL_YES : $PROFIL_NO)
		.sprintf($REGISTER_MAIL_BODY15,$theme).sprintf($REGISTER_MAIL_BODY16,$info).$REGISTER_MAIL_BODY17.$REGISTER_MAIL_BODY18;
	  if (!isset($GLOBALS['sessionid']))
//	  	$MAIL_BODY .= "http://" . getenv("SERVER_NAME") . str_replace('register.php', $confirmation_link, $PHP_SELF);
	  	$MAIL_BODY .= "http://" . getenv("HTTP_HOST") . str_replace('register.php', $confirmation_link, $PHP_SELF);
	  else
//	  	$MAIL_BODY .= "http://" . getenv("SERVER_NAME") . str_replace('phpgw_register.php', $confirmation_link, $PHP_SELF);
	  	$MAIL_BODY .= "http://" . getenv("HTTP_HOST") . str_replace('phpgw_register.php', $confirmation_link, $PHP_SELF);
      include('send_mail_inc.'.$FILE_EXTENSION);
	  include("jcode.phps");
	  $subject = '=?iso-2022-jp?B?'.base64_encode(jcodeconvert($REGISTER_MAIL_SUBJECT,1,3)).'?=';
	  $body = jcodeconvert($MAIL_BODY,1,3);
      if(send_mail($user_email,$subject,$body))
	  {
//      if(send_mail($user_email,$MAIL_SUBJECT.$CHATNAME,$MAIL_BODY)){
        $success = $REGISTER_SUCCESS_MAIL_1.'<a href="'.$confirmation_link.'">'.$REGISTER_SUCCESS_MAIL_2.'</a>';
//        $success = $REGISTER_SUCCESS_MAIL_1.$successlink.$REGISTER_SUCCESS_MAIL_2.'</a>';
		$show = TRUE;
      }else{
	  	  $show = FALSE;
	  	  $success = 'error sending mail';
      }
    }else{
	  $show = TRUE;
      $success = $REGISTER_SUCCESS_1.$successlink.$REGISTER_SUCCESS_2;
    }
  }
}else{
  
}
if (!isset($GLOBALS['sessionid']))
	include("register_tpl.php");
?>
