<?php
	/*****************************************************************************\
	* phpGroupWare - boForums                                                     *
	* http://www.phpgroupware.org                                                 *
	* Written by Mark A Peters <skeeter@phpgroupware.org>                         *
	* Based off of Jani Hirvinen <jpkh@shadownet.com>                             *
	* -------------------------------------------                                 *
	*  This program is free software; you	can redistribute it and/or modify it  *
	*  under the terms of	the GNU	General	Public License as published by the    *
	*  Free Software Foundation; either version 2	of the License,	or (at your   *
	*  option) any later version.                                                 *
	\*****************************************************************************/

	/* $Id: class.boforum.inc.php,v 1.1.2.6 2002/02/15 03:54:59 skeeter Exp $ */

	class boforum
	{
		var $public_functions = array(
			'reply' => True,
			'post'  => True,
			'delete_category'	=> True,
			'delete_forum'	=> True,
			'category'	=> True,
			'forum'	=> True,
			//Added By Kazuya Nouchi POPCOM INC
			'delete_topic'	=> True
		);

		var $debug = False;
		
		var $so;

		var $use_session;

		var $view;
		var $location;
		var $cat_id = False;
		var $forum_id = False;
		
		function boforum($session=0)
		{
			$this->so = CreateObject('forum.soforum');
			if($session)
			{
                $this->read_sessiondata();
				$this->use_session = True;
			}

			$var = Array(
				'view',
				'location',
				'cat_id',
				'forum_id'
			);
            // Added By Kazuya Nouchi POPCOM INC 2002/12/13
            $now_cat_id = (@isset($GLOBALS['HTTP_POST_VARS']['cat_id']) ? $GLOBALS['HTTP_POST_VARS']['cat_id'] : $GLOBALS['HTTP_GET_VARS']['cat_id']);
            if (@isset($now_cat_id) && $now_cat_id != $this->cat_id)
                unset($this->forum_id);
            //--------------------------------------------------
			for($i=0;$i<count($var);$i++)
			{
				$var_str = $var[$i];
//				$this->$var_str = (@isset($GLOBALS['HTTP_GET_VARS'][$var_str])?intval($GLOBALS['HTTP_GET_VARS'][$var_str]):$this->$var_str);
//				$this->$var_str = (@isset($GLOBALS['HTTP_POST_VARS'][$var_str])?intval($GLOBALS['HTTP_POST_VARS'][$var_str]):$this->$var_str);
				$this->$var_str = (@isset($GLOBALS['HTTP_GET_VARS'][$var_str])?$GLOBALS['HTTP_GET_VARS'][$var_str]:$this->$var_str);
				$this->$var_str = (@isset($GLOBALS['HTTP_POST_VARS'][$var_str])?$GLOBALS['HTTP_POST_VARS'][$var_str]:$this->$var_str);
			}
			
			if(!@isset($this->view))
			{
				$this->view = $GLOBALS['phpgw_info']['user']['preferences']['forum']['default_view'];
			}
			// Added By Kazuya Nouchi POPCOM INC 2002/6/7
			if (!$this->cat_id)
			{
				$cat_info = $this->get_all_cat_info();
                if (is_array($cat_info))
                {
                    $this->cat_id = $cat_info[0]['id'];
                    $this->forum_id = False;
                    $data['view'] = $this->view ;
                    $data['location'] = $this->location;
                    $data['cat_id'] = $this->cat_id;
                    $data['forum_id'] = $this->forum_id;
                    $this->save_sessiondata($data);
                }
                else
				    $this->cat_id = 0;
			}
			if (!$this->forum_id)
			{
				$forum_info = $this->get_forums_for_cat($this->cat_id);
				if (is_array($forum_info))
                {
					$this->forum_id = $forum_info[0]['id'];
                    $data['view'] = $this->view;
                    $data['location'] = $this->location;
                    $data['cat_id'] = $this->cat_id;
                    $data['forum_id'] = $this->forum_id;
                    $this->save_sessiondata($data);
                }
				else
					$this->forum_id = 0;
			}
			//-----------------------------------------
		}

		function save_sessiondata($data)
		{
			if ($this->use_session)
			{
				if($this->debug) { echo '<br>Save:'; _debug_array($data); }
				$GLOBALS['phpgw']->session->appsession('session_data','forum',$data);
			}
		}

		function read_sessiondata()
		{
			$data = $GLOBALS['phpgw']->session->appsession('session_data','forum');
			if($this->debug) { echo '<br>Read:'; _debug_array($data); }

			$this->view     = $data['view'];
			$this->location = $data['location'];
			$this->cat_id   = $data['cat_id'];
			$this->forum_id = $data['forum_id'];
		}
		
		function post()
		{
			if ($GLOBALS['HTTP_POST_VARS']['action'] == 'post')
			{
				$data = Array(
					'cat_id'	=> $GLOBALS['HTTP_POST_VARS']['cat_id'],
					'forum_id'	=> $GLOBALS['HTTP_POST_VARS']['forum_id'],
					'postdate'	=> time() - ((60 * 60) * intval($GLOBALS['phpgw_info']['user']['preferences']['common']['tz_offset'])),
					'subject'	=> $GLOBALS['HTTP_POST_VARS']['subject'],
					'message'	=> $GLOBALS['HTTP_POST_VARS']['message']
				);

				$this->so->add_post($data);
			}
			// Modified By Kazuya Nouchi POPCOM INC 2002/8/2
			$GLOBALS['phpgw']->redirect($GLOBALS['phpgw']->link('/index.php','menuaction=forum.uiforum.index'));
//			$GLOBALS['phpgw']->redirect($GLOBALS['phpgw']->link('/index.php','menuaction=forum.uiforum.threads'));
			//------------------------------------------------------
			$GLOBALS['phpgw']->common->phpgw_exit();
		}

		function reply()
		{
			if ($GLOBALS['HTTP_POST_VARS']['action'] == 'reply')
			{
				$stat = 0;

				$next_f_body_id = $this->so->get_max_body_id() + 1;

				$next_f_threads_id = $this->so->get_max_thread_id() + 1;
				

				if ($GLOBALS['HTTP_POST_VARS']['pos'] != 0)
				{
					$this->so->fix_pos($GLOBALS['HTTP_POST_VARS']['thread'],$GLOBALS['HTTP_POST_VARS']['pos']);
				}
				else
				{
					$GLOBALS['HTTP_POST_VARS']['pos'] = 1;
				}

				$data = Array(
					'pos' => $GLOBALS['HTTP_POST_VARS']['pos'],
					'thread'	=> $GLOBALS['HTTP_POST_VARS']['thread'],
					'depth'	=> $GLOBALS['HTTP_POST_VARS']['depth'],
					'postdate'	=> time() - ((60 * 60) * intval($GLOBALS['phpgw_info']['user']['preferences']['common']['tz_offset'])),
					'parent'	=> $GLOBALS['HTTP_POST_VARS']['msg'],
					'cat_id'	=> $GLOBALS['HTTP_POST_VARS']['cat_id'],
					'forum_id'	=> $GLOBALS['HTTP_POST_VARS']['forum_id'],
					'subject'	=> $GLOBALS['HTTP_POST_VARS']['subject'],
					'message'	=> $GLOBALS['HTTP_POST_VARS']['message']
				);

				$this->so->add_reply($data);
			}
			// Modified By Kazuya Nouchi POPCOM INC 2002/6/7
//			if ($GLOBALS['phpgw_info']['server']['template_set'] != 'savant')
//				Header('Location: '.$GLOBALS['phpgw']->link('/index.php','menuaction=forum.uiforum.threads'));
//			else
				Header('Location: '.$GLOBALS['phpgw']->link('/index.php','menuaction=forum.uiforum.index'));
			//-------------------------------------------------------------------
			$GLOBALS['phpgw']->common->phpgw_exit();
		}

		function delete_category()
		{
			if(!$GLOBALS['phpgw_info']['user']['apps']['admin'])
			{
				Header('Location: '.$GLOBALS['phpgw']->link('/index.php','menuaction=forum.uiforum.index'));
				$GLOBALS['phpgw']->common->phpgw_exit();
			}
			$this->so->delete_category($this->cat_id);
            // Added By Kazuya Nouchi POPCOM INC 2002/12/10
            unset($this->cat_id);
            unset($this->forum_id);
            $data['view'] = $this->view;
            $data['location'] = $this->location;
            $data['cat_id'] = $this->cat_id;
            $data['forum_id'] = $this->forum_id;
            $this->use_session = True;
            $this->save_sessiondata($data);
            //-------------------------------------------------------------------
			Header('Location: '.$GLOBALS['phpgw']->link('/index.php','menuaction=forum.uiadmin.index'));
			$GLOBALS['phpgw']->common->phpgw_exit();
		}

		function delete_forum()
		{
			if(!$GLOBALS['phpgw_info']['user']['apps']['admin'])
			{
				Header('Location: '.$GLOBALS['phpgw']->link('/index.php','menuaction=forum.uiforum.index'));
				$GLOBALS['phpgw']->common->phpgw_exit();
			}
			$this->so->delete_forum($this->cat_id,$this->forum_id);
            // Added By Kazuya Nouchi POPCOM INC 2002/12/10
            unset($this->forum_id);
            $data['view'] = $this->view;
            $data['location'] = $this->location;
            $data['cat_id'] = $this->cat_id;
            $data['forum_id'] = $this->forum_id;
            $this->use_session = True;
            $this->save_sessiondata($data);
            //-------------------------------------------------------------------
			Header('Location: '.$GLOBALS['phpgw']->link('/index.php','menuaction=forum.uiadmin.index'));
			$GLOBALS['phpgw']->common->phpgw_exit();
		}
		
		// Added By Kazuya Nouchi POPCOM INC 2002/6/7
		function delete_topic()
		{
			$thread = (@isset($GLOBALS['HTTP_POST_VARS']['thread'])?$GLOBALS['HTTP_POST_VARS']['thread']:$GLOBALS['HTTP_GET_VARS']['thread']);
			$topic_id = (@isset($GLOBALS['HTTP_POST_VARS']['msg'])?$GLOBALS['HTTP_POST_VARS']['msg']:$GLOBALS['HTTP_GET_VARS']['msg']);
			$action = (@isset($GLOBALS['HTTP_POST_VARS']['action'])?$GLOBALS['HTTP_POST_VARS']['action']:$GLOBALS['HTTP_GET_VARS']['action']);
			$pos = (@isset($GLOBALS['HTTP_POST_VARS']['pos'])?$GLOBALS['HTTP_POST_VARS']['pos']:$GLOBALS['HTTP_GET_VARS']['pos']);

            // Modified By Kazuya Nouchi POPCOM INC 2002/12/17
			//if(!$GLOBALS['phpgw_info']['user']['apps']['admin'] || !$topic_id || $action != 'delete' || !$thread || $pos < 0)
            if(!$topic_id || $action != 'delete' || !$thread || $pos < 0)
            //-----------------------------------------------------------------
			{
				Header('Location: '.$GLOBALS['phpgw']->link('/index.php','menuaction=forum.uiforum.index'));
				$GLOBALS['phpgw']->common->phpgw_exit();
			}
			$this->so->delete_topic($this->cat_id,$this->forum_id,$thread,$topic_id);
			Header('Location: '.$GLOBALS['phpgw']->link('/index.php','menuaction=forum.uiforum.index'));
			$GLOBALS['phpgw']->common->phpgw_exit();		
		}
		//----------------------------------------------------------

		function category()
		{
			if(!$GLOBALS['phpgw_info']['user']['apps']['admin'])
			{
				Header('Location: '.$GLOBALS['phpgw']->link('/index.php','menuaction=forum.uiforum.index'));
				$GLOBALS['phpgw']->common->phpgw_exit();
			}
			$this->so->save_category($GLOBALS['HTTP_POST_VARS']['cat']);
			Header('Location: '.$GLOBALS['phpgw']->link('/index.php','menuaction=forum.uiadmin.index'));
			$GLOBALS['phpgw']->common->phpgw_exit();
		}

		function forum()
		{
			if(!$GLOBALS['phpgw_info']['user']['apps']['admin'])
			{
				Header('Location: '.$GLOBALS['phpgw']->link('/index.php','menuaction=forum.uiforum.index'));
				$GLOBALS['phpgw']->common->phpgw_exit();
			}
			$this->so->save_forum($GLOBALS['HTTP_POST_VARS']['forum']);
			Header('Location: '.$GLOBALS['phpgw']->link('/index.php','menuaction=forum.uiadmin.index'));
			$GLOBALS['phpgw']->common->phpgw_exit();
		}

		function get_all_cat_info()
		{
			$cats = $this->so->get_cat_ids();
			if (!is_array($cats))
				return False;
			while(list($key,$cat) = each($cats))
			{
				$summary[$key] = $cat;
				$temp = $this->so->get_thread_summary($cat['id']);
				$summary[$key]['last_post'] = $temp['last_post'];
				$summary[$key]['total'] = $temp['total'];
			}
			return $summary;
		}

		function get_cat_info($cat_id)
		{
			return $this->so->get_cat_info($cat_id);
		}

		function get_forum_info($cat_id,$forum_id)
		{
			$forum = $this->so->get_forum_info($cat_id,$forum_id);
			return $forum[0];
		}

		function get_forums_for_cat($cat_id)
		{
			$forums = $this->so->get_forum_info($cat_id);
			while($forums && list($key,$forum) = each($forums))
			{
				$summary[$key] = $forum;
				$temp = $this->so->get_thread_summary($cat_id,$forum['id']);
				$summary[$key]['last_post'] = $temp['last_post'];
				$summary[$key]['total'] = $temp['total'];
			}
			return $summary;
		}
		
		function get_thread($cat_id,$forum_id,$collapsed=False)
		{
			// Modified By Kazuya Nouchi POPCOM INC 2002/8/2
			$curver = explode(".", phpversion());
			if ($curver[0] == 4 && $curver[1] >= 1)
			{
				$tmp_threads = $this->so->get_thread($cat_id,$forum_id,$collapsed);
				if (!is_array($tmp_threads)) return False;
				foreach ($tmp_threads as $key => $val)
				{
					$parent = $val['parent'];
					if (array_key_exists($parent,$tmp_threads))
					{
						$tmp_array = explode($parent, $order);
						if (count($tmp_array) == 2)
							$order = $tmp_array[0]."$parent,".$key.$tmp_array[1];
						else
							$order .= (string)$key.',';
					}
					else
						$order .= (string)$key.',';
				}
				unset($tmp_array);
				$order = substr($order,0,strlen($order)-1); 		// last comma removed 
				$tmp_array = explode(',',$order);
				for ($i = 0;$i < count($tmp_array); $i++)
				{
					$key = $tmp_array[$i];
					$threads[] = $tmp_threads[$key];
				}
			}
			else
				$threads = $this->so->get_thread($cat_id,$forum_id,$collapsed);
			return $threads;			
			//-----------------------------------------------------------------
		}

		function read_msg($cat_id,$forum_id,$msg_id)
		{
			// Modified By Kazuya Nouchi POPCOM INC 2002/8/2
			$curver = explode(".", phpversion());
			if ($curver[0] == 4 && $curver[1] >= 1)
			{
				$tmp_msgs = $this->so->read_msg($cat_id,$forum_id,$msg_id);
				if (is_array($tmp_msgs))
				{
					foreach ($tmp_msgs as $key => $val)
					{
						$parent = $val['parent'];
						if (array_key_exists($parent,$tmp_msgs))
						{
							$tmp_array = explode($parent, $order);
							if (count($tmp_array) == 2)
								$order = $tmp_array[0]."$parent,".$key.$tmp_array[1];
							else
								$order .= (string)$key.',';
						}
						else
							$order .= (string)$key.',';
					}
					unset($tmp_array);
				}
				$order = substr($order,0,strlen($order)-1); 		// last comma removed 
				$tmp_array = explode(',',$order);
				for ($i = 0;$i < count($tmp_array); $i++)
				{
					$key = $tmp_array[$i];
					$msgs[] = $tmp_msgs[$key];
				}
			}
			else
				$msgs = $this->so->read_msg($cat_id,$forum_id,$msg_id);
			return $msgs;			
			//-----------------------------------------------------------------		
		
		
		
		
			// Modified By Kazuya Nouchi POPCOM INC 2002/6/7
			return $this->so->read_msg($cat_id,$forum_id,$msg_id);
/*
			$tmp_msgs = $this->so->read_msg($cat_id,$forum_id,$msg_id);
			unset($msgs);
			for ($i = 0;is_array($tmp_msgs[$i]); $i++)
			{
				if ($tmp_msgs[$i]['parent'] == -1)
				{
					$msgs[] = $tmp_msgs[$i];
				}
				else if (count($msgs) < count($tmp_msgs))
				{
					if (!isset($tmp_msgs[$i]['flag']))
						$msgs[] = $tmp_msgs[$i];
					for ($j=$i+1;is_array($tmp_msgs[$j]); $j++)
					{
						if ($tmp_msgs[$i]['id'] == $tmp_msgs[$j]['parent'])
						{
							$msgs[] = $tmp_msgs[$j];
							$tmp_msgs[$j]['flag'] = true;
						}
					}
				}
			}
			return $msgs;
*/
		}
		// Added By Kazuya Nouchi POPCOM INC 2003/1/29
		function search_keywords($keywords, $cat_id='', $forum_id='')
		{
			return $this->so->search_keywords($keywords, $cat_id, $forum_id);
		}		
		// --------------------------------------------------------------------
	}
?>
